/**
 * Autogenerated by Thrift
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 */
package se.kth.livetech.communication.thrift;

import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
import java.util.Set;
import java.util.HashSet;
import java.util.Collections;
import java.util.BitSet;
import java.util.Arrays;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import org.apache.thrift.*;
import org.apache.thrift.meta_data.*;
import org.apache.thrift.protocol.*;

public class LiveService {

  public interface Iface {

    public NodeId getNodeId() throws TException;

    public void attach(NodeId node) throws TException;

    public void detach() throws TException;

    public void addNode(NodeId node) throws TException;

    public void removeNode(NodeId node) throws TException;

    public List<NodeId> getNodes() throws TException;

    public List<NodeStatus> getNodeStatus() throws TException;

    public long time() throws TException;

    public byte[] getClass(String className) throws TException;

    public void classUpdate(String className) throws TException;

    public byte[] getResource(String resourceName) throws TException;

    public void resourceUpdate(String resourceName) throws TException;

    public List<PropertyEvent> getProperties() throws TException;

    public String getProperty(String key) throws TException;

    public void setProperty(String key, String value) throws TException;

    public ContestDump getContest(ContestId contest) throws TException;

    public void addContest(ContestId contest) throws TException;

    public void removeContest(ContestId contest) throws TException;

    public void propertyUpdate(PropertyEvent event) throws TException;

    public void contestUpdate(ContestId contest, ContestEvent event) throws TException;

    public void logEvent(LogEvent event) throws TException;

    public void logSubscribe(LogEvent template) throws TException;

    public void logUnsubscribe(LogEvent template) throws TException;

  }

  public static class Client implements Iface {
    public Client(TProtocol prot)
    {
      this(prot, prot);
    }

    public Client(TProtocol iprot, TProtocol oprot)
    {
      iprot_ = iprot;
      oprot_ = oprot;
    }

    protected TProtocol iprot_;
    protected TProtocol oprot_;

    protected int seqid_;

    public TProtocol getInputProtocol()
    {
      return this.iprot_;
    }

    public TProtocol getOutputProtocol()
    {
      return this.oprot_;
    }

    public NodeId getNodeId() throws TException
    {
      send_getNodeId();
      return recv_getNodeId();
    }

    public void send_getNodeId() throws TException
    {
      oprot_.writeMessageBegin(new TMessage("getNodeId", TMessageType.CALL, seqid_));
      getNodeId_args args = new getNodeId_args();
      args.write(oprot_);
      oprot_.writeMessageEnd();
      oprot_.getTransport().flush();
    }

    public NodeId recv_getNodeId() throws TException
    {
      TMessage msg = iprot_.readMessageBegin();
      if (msg.type == TMessageType.EXCEPTION) {
        TApplicationException x = TApplicationException.read(iprot_);
        iprot_.readMessageEnd();
        throw x;
      }
      getNodeId_result result = new getNodeId_result();
      result.read(iprot_);
      iprot_.readMessageEnd();
      if (result.isSetSuccess()) {
        return result.success;
      }
      throw new TApplicationException(TApplicationException.MISSING_RESULT, "getNodeId failed: unknown result");
    }

    public void attach(NodeId node) throws TException
    {
      send_attach(node);
      recv_attach();
    }

    public void send_attach(NodeId node) throws TException
    {
      oprot_.writeMessageBegin(new TMessage("attach", TMessageType.CALL, seqid_));
      attach_args args = new attach_args();
      args.node = node;
      args.write(oprot_);
      oprot_.writeMessageEnd();
      oprot_.getTransport().flush();
    }

    public void recv_attach() throws TException
    {
      TMessage msg = iprot_.readMessageBegin();
      if (msg.type == TMessageType.EXCEPTION) {
        TApplicationException x = TApplicationException.read(iprot_);
        iprot_.readMessageEnd();
        throw x;
      }
      attach_result result = new attach_result();
      result.read(iprot_);
      iprot_.readMessageEnd();
      return;
    }

    public void detach() throws TException
    {
      send_detach();
      recv_detach();
    }

    public void send_detach() throws TException
    {
      oprot_.writeMessageBegin(new TMessage("detach", TMessageType.CALL, seqid_));
      detach_args args = new detach_args();
      args.write(oprot_);
      oprot_.writeMessageEnd();
      oprot_.getTransport().flush();
    }

    public void recv_detach() throws TException
    {
      TMessage msg = iprot_.readMessageBegin();
      if (msg.type == TMessageType.EXCEPTION) {
        TApplicationException x = TApplicationException.read(iprot_);
        iprot_.readMessageEnd();
        throw x;
      }
      detach_result result = new detach_result();
      result.read(iprot_);
      iprot_.readMessageEnd();
      return;
    }

    public void addNode(NodeId node) throws TException
    {
      send_addNode(node);
      recv_addNode();
    }

    public void send_addNode(NodeId node) throws TException
    {
      oprot_.writeMessageBegin(new TMessage("addNode", TMessageType.CALL, seqid_));
      addNode_args args = new addNode_args();
      args.node = node;
      args.write(oprot_);
      oprot_.writeMessageEnd();
      oprot_.getTransport().flush();
    }

    public void recv_addNode() throws TException
    {
      TMessage msg = iprot_.readMessageBegin();
      if (msg.type == TMessageType.EXCEPTION) {
        TApplicationException x = TApplicationException.read(iprot_);
        iprot_.readMessageEnd();
        throw x;
      }
      addNode_result result = new addNode_result();
      result.read(iprot_);
      iprot_.readMessageEnd();
      return;
    }

    public void removeNode(NodeId node) throws TException
    {
      send_removeNode(node);
      recv_removeNode();
    }

    public void send_removeNode(NodeId node) throws TException
    {
      oprot_.writeMessageBegin(new TMessage("removeNode", TMessageType.CALL, seqid_));
      removeNode_args args = new removeNode_args();
      args.node = node;
      args.write(oprot_);
      oprot_.writeMessageEnd();
      oprot_.getTransport().flush();
    }

    public void recv_removeNode() throws TException
    {
      TMessage msg = iprot_.readMessageBegin();
      if (msg.type == TMessageType.EXCEPTION) {
        TApplicationException x = TApplicationException.read(iprot_);
        iprot_.readMessageEnd();
        throw x;
      }
      removeNode_result result = new removeNode_result();
      result.read(iprot_);
      iprot_.readMessageEnd();
      return;
    }

    public List<NodeId> getNodes() throws TException
    {
      send_getNodes();
      return recv_getNodes();
    }

    public void send_getNodes() throws TException
    {
      oprot_.writeMessageBegin(new TMessage("getNodes", TMessageType.CALL, seqid_));
      getNodes_args args = new getNodes_args();
      args.write(oprot_);
      oprot_.writeMessageEnd();
      oprot_.getTransport().flush();
    }

    public List<NodeId> recv_getNodes() throws TException
    {
      TMessage msg = iprot_.readMessageBegin();
      if (msg.type == TMessageType.EXCEPTION) {
        TApplicationException x = TApplicationException.read(iprot_);
        iprot_.readMessageEnd();
        throw x;
      }
      getNodes_result result = new getNodes_result();
      result.read(iprot_);
      iprot_.readMessageEnd();
      if (result.isSetSuccess()) {
        return result.success;
      }
      throw new TApplicationException(TApplicationException.MISSING_RESULT, "getNodes failed: unknown result");
    }

    public List<NodeStatus> getNodeStatus() throws TException
    {
      send_getNodeStatus();
      return recv_getNodeStatus();
    }

    public void send_getNodeStatus() throws TException
    {
      oprot_.writeMessageBegin(new TMessage("getNodeStatus", TMessageType.CALL, seqid_));
      getNodeStatus_args args = new getNodeStatus_args();
      args.write(oprot_);
      oprot_.writeMessageEnd();
      oprot_.getTransport().flush();
    }

    public List<NodeStatus> recv_getNodeStatus() throws TException
    {
      TMessage msg = iprot_.readMessageBegin();
      if (msg.type == TMessageType.EXCEPTION) {
        TApplicationException x = TApplicationException.read(iprot_);
        iprot_.readMessageEnd();
        throw x;
      }
      getNodeStatus_result result = new getNodeStatus_result();
      result.read(iprot_);
      iprot_.readMessageEnd();
      if (result.isSetSuccess()) {
        return result.success;
      }
      throw new TApplicationException(TApplicationException.MISSING_RESULT, "getNodeStatus failed: unknown result");
    }

    public long time() throws TException
    {
      send_time();
      return recv_time();
    }

    public void send_time() throws TException
    {
      oprot_.writeMessageBegin(new TMessage("time", TMessageType.CALL, seqid_));
      time_args args = new time_args();
      args.write(oprot_);
      oprot_.writeMessageEnd();
      oprot_.getTransport().flush();
    }

    public long recv_time() throws TException
    {
      TMessage msg = iprot_.readMessageBegin();
      if (msg.type == TMessageType.EXCEPTION) {
        TApplicationException x = TApplicationException.read(iprot_);
        iprot_.readMessageEnd();
        throw x;
      }
      time_result result = new time_result();
      result.read(iprot_);
      iprot_.readMessageEnd();
      if (result.isSetSuccess()) {
        return result.success;
      }
      throw new TApplicationException(TApplicationException.MISSING_RESULT, "time failed: unknown result");
    }

    public byte[] getClass(String className) throws TException
    {
      send_getClass(className);
      return recv_getClass();
    }

    public void send_getClass(String className) throws TException
    {
      oprot_.writeMessageBegin(new TMessage("getClass", TMessageType.CALL, seqid_));
      getClass_args args = new getClass_args();
      args.className = className;
      args.write(oprot_);
      oprot_.writeMessageEnd();
      oprot_.getTransport().flush();
    }

    public byte[] recv_getClass() throws TException
    {
      TMessage msg = iprot_.readMessageBegin();
      if (msg.type == TMessageType.EXCEPTION) {
        TApplicationException x = TApplicationException.read(iprot_);
        iprot_.readMessageEnd();
        throw x;
      }
      getClass_result result = new getClass_result();
      result.read(iprot_);
      iprot_.readMessageEnd();
      if (result.isSetSuccess()) {
        return result.success;
      }
      throw new TApplicationException(TApplicationException.MISSING_RESULT, "getClass failed: unknown result");
    }

    public void classUpdate(String className) throws TException
    {
      send_classUpdate(className);
    }

    public void send_classUpdate(String className) throws TException
    {
      oprot_.writeMessageBegin(new TMessage("classUpdate", TMessageType.CALL, seqid_));
      classUpdate_args args = new classUpdate_args();
      args.className = className;
      args.write(oprot_);
      oprot_.writeMessageEnd();
      oprot_.getTransport().flush();
    }

    public byte[] getResource(String resourceName) throws TException
    {
      send_getResource(resourceName);
      return recv_getResource();
    }

    public void send_getResource(String resourceName) throws TException
    {
      oprot_.writeMessageBegin(new TMessage("getResource", TMessageType.CALL, seqid_));
      getResource_args args = new getResource_args();
      args.resourceName = resourceName;
      args.write(oprot_);
      oprot_.writeMessageEnd();
      oprot_.getTransport().flush();
    }

    public byte[] recv_getResource() throws TException
    {
      TMessage msg = iprot_.readMessageBegin();
      if (msg.type == TMessageType.EXCEPTION) {
        TApplicationException x = TApplicationException.read(iprot_);
        iprot_.readMessageEnd();
        throw x;
      }
      getResource_result result = new getResource_result();
      result.read(iprot_);
      iprot_.readMessageEnd();
      if (result.isSetSuccess()) {
        return result.success;
      }
      throw new TApplicationException(TApplicationException.MISSING_RESULT, "getResource failed: unknown result");
    }

    public void resourceUpdate(String resourceName) throws TException
    {
      send_resourceUpdate(resourceName);
    }

    public void send_resourceUpdate(String resourceName) throws TException
    {
      oprot_.writeMessageBegin(new TMessage("resourceUpdate", TMessageType.CALL, seqid_));
      resourceUpdate_args args = new resourceUpdate_args();
      args.resourceName = resourceName;
      args.write(oprot_);
      oprot_.writeMessageEnd();
      oprot_.getTransport().flush();
    }

    public List<PropertyEvent> getProperties() throws TException
    {
      send_getProperties();
      return recv_getProperties();
    }

    public void send_getProperties() throws TException
    {
      oprot_.writeMessageBegin(new TMessage("getProperties", TMessageType.CALL, seqid_));
      getProperties_args args = new getProperties_args();
      args.write(oprot_);
      oprot_.writeMessageEnd();
      oprot_.getTransport().flush();
    }

    public List<PropertyEvent> recv_getProperties() throws TException
    {
      TMessage msg = iprot_.readMessageBegin();
      if (msg.type == TMessageType.EXCEPTION) {
        TApplicationException x = TApplicationException.read(iprot_);
        iprot_.readMessageEnd();
        throw x;
      }
      getProperties_result result = new getProperties_result();
      result.read(iprot_);
      iprot_.readMessageEnd();
      if (result.isSetSuccess()) {
        return result.success;
      }
      throw new TApplicationException(TApplicationException.MISSING_RESULT, "getProperties failed: unknown result");
    }

    public String getProperty(String key) throws TException
    {
      send_getProperty(key);
      return recv_getProperty();
    }

    public void send_getProperty(String key) throws TException
    {
      oprot_.writeMessageBegin(new TMessage("getProperty", TMessageType.CALL, seqid_));
      getProperty_args args = new getProperty_args();
      args.key = key;
      args.write(oprot_);
      oprot_.writeMessageEnd();
      oprot_.getTransport().flush();
    }

    public String recv_getProperty() throws TException
    {
      TMessage msg = iprot_.readMessageBegin();
      if (msg.type == TMessageType.EXCEPTION) {
        TApplicationException x = TApplicationException.read(iprot_);
        iprot_.readMessageEnd();
        throw x;
      }
      getProperty_result result = new getProperty_result();
      result.read(iprot_);
      iprot_.readMessageEnd();
      if (result.isSetSuccess()) {
        return result.success;
      }
      throw new TApplicationException(TApplicationException.MISSING_RESULT, "getProperty failed: unknown result");
    }

    public void setProperty(String key, String value) throws TException
    {
      send_setProperty(key, value);
      recv_setProperty();
    }

    public void send_setProperty(String key, String value) throws TException
    {
      oprot_.writeMessageBegin(new TMessage("setProperty", TMessageType.CALL, seqid_));
      setProperty_args args = new setProperty_args();
      args.key = key;
      args.value = value;
      args.write(oprot_);
      oprot_.writeMessageEnd();
      oprot_.getTransport().flush();
    }

    public void recv_setProperty() throws TException
    {
      TMessage msg = iprot_.readMessageBegin();
      if (msg.type == TMessageType.EXCEPTION) {
        TApplicationException x = TApplicationException.read(iprot_);
        iprot_.readMessageEnd();
        throw x;
      }
      setProperty_result result = new setProperty_result();
      result.read(iprot_);
      iprot_.readMessageEnd();
      return;
    }

    public ContestDump getContest(ContestId contest) throws TException
    {
      send_getContest(contest);
      return recv_getContest();
    }

    public void send_getContest(ContestId contest) throws TException
    {
      oprot_.writeMessageBegin(new TMessage("getContest", TMessageType.CALL, seqid_));
      getContest_args args = new getContest_args();
      args.contest = contest;
      args.write(oprot_);
      oprot_.writeMessageEnd();
      oprot_.getTransport().flush();
    }

    public ContestDump recv_getContest() throws TException
    {
      TMessage msg = iprot_.readMessageBegin();
      if (msg.type == TMessageType.EXCEPTION) {
        TApplicationException x = TApplicationException.read(iprot_);
        iprot_.readMessageEnd();
        throw x;
      }
      getContest_result result = new getContest_result();
      result.read(iprot_);
      iprot_.readMessageEnd();
      if (result.isSetSuccess()) {
        return result.success;
      }
      throw new TApplicationException(TApplicationException.MISSING_RESULT, "getContest failed: unknown result");
    }

    public void addContest(ContestId contest) throws TException
    {
      send_addContest(contest);
      recv_addContest();
    }

    public void send_addContest(ContestId contest) throws TException
    {
      oprot_.writeMessageBegin(new TMessage("addContest", TMessageType.CALL, seqid_));
      addContest_args args = new addContest_args();
      args.contest = contest;
      args.write(oprot_);
      oprot_.writeMessageEnd();
      oprot_.getTransport().flush();
    }

    public void recv_addContest() throws TException
    {
      TMessage msg = iprot_.readMessageBegin();
      if (msg.type == TMessageType.EXCEPTION) {
        TApplicationException x = TApplicationException.read(iprot_);
        iprot_.readMessageEnd();
        throw x;
      }
      addContest_result result = new addContest_result();
      result.read(iprot_);
      iprot_.readMessageEnd();
      return;
    }

    public void removeContest(ContestId contest) throws TException
    {
      send_removeContest(contest);
      recv_removeContest();
    }

    public void send_removeContest(ContestId contest) throws TException
    {
      oprot_.writeMessageBegin(new TMessage("removeContest", TMessageType.CALL, seqid_));
      removeContest_args args = new removeContest_args();
      args.contest = contest;
      args.write(oprot_);
      oprot_.writeMessageEnd();
      oprot_.getTransport().flush();
    }

    public void recv_removeContest() throws TException
    {
      TMessage msg = iprot_.readMessageBegin();
      if (msg.type == TMessageType.EXCEPTION) {
        TApplicationException x = TApplicationException.read(iprot_);
        iprot_.readMessageEnd();
        throw x;
      }
      removeContest_result result = new removeContest_result();
      result.read(iprot_);
      iprot_.readMessageEnd();
      return;
    }

    public void propertyUpdate(PropertyEvent event) throws TException
    {
      send_propertyUpdate(event);
    }

    public void send_propertyUpdate(PropertyEvent event) throws TException
    {
      oprot_.writeMessageBegin(new TMessage("propertyUpdate", TMessageType.CALL, seqid_));
      propertyUpdate_args args = new propertyUpdate_args();
      args.event = event;
      args.write(oprot_);
      oprot_.writeMessageEnd();
      oprot_.getTransport().flush();
    }

    public void contestUpdate(ContestId contest, ContestEvent event) throws TException
    {
      send_contestUpdate(contest, event);
    }

    public void send_contestUpdate(ContestId contest, ContestEvent event) throws TException
    {
      oprot_.writeMessageBegin(new TMessage("contestUpdate", TMessageType.CALL, seqid_));
      contestUpdate_args args = new contestUpdate_args();
      args.contest = contest;
      args.event = event;
      args.write(oprot_);
      oprot_.writeMessageEnd();
      oprot_.getTransport().flush();
    }

    public void logEvent(LogEvent event) throws TException
    {
      send_logEvent(event);
    }

    public void send_logEvent(LogEvent event) throws TException
    {
      oprot_.writeMessageBegin(new TMessage("logEvent", TMessageType.CALL, seqid_));
      logEvent_args args = new logEvent_args();
      args.event = event;
      args.write(oprot_);
      oprot_.writeMessageEnd();
      oprot_.getTransport().flush();
    }

    public void logSubscribe(LogEvent template) throws TException
    {
      send_logSubscribe(template);
    }

    public void send_logSubscribe(LogEvent template) throws TException
    {
      oprot_.writeMessageBegin(new TMessage("logSubscribe", TMessageType.CALL, seqid_));
      logSubscribe_args args = new logSubscribe_args();
      args.template = template;
      args.write(oprot_);
      oprot_.writeMessageEnd();
      oprot_.getTransport().flush();
    }

    public void logUnsubscribe(LogEvent template) throws TException
    {
      send_logUnsubscribe(template);
    }

    public void send_logUnsubscribe(LogEvent template) throws TException
    {
      oprot_.writeMessageBegin(new TMessage("logUnsubscribe", TMessageType.CALL, seqid_));
      logUnsubscribe_args args = new logUnsubscribe_args();
      args.template = template;
      args.write(oprot_);
      oprot_.writeMessageEnd();
      oprot_.getTransport().flush();
    }

  }
  public static class Processor implements TProcessor {
    private static final Logger LOGGER = LoggerFactory.getLogger(Processor.class.getName());
    public Processor(Iface iface)
    {
      iface_ = iface;
      processMap_.put("getNodeId", new getNodeId());
      processMap_.put("attach", new attach());
      processMap_.put("detach", new detach());
      processMap_.put("addNode", new addNode());
      processMap_.put("removeNode", new removeNode());
      processMap_.put("getNodes", new getNodes());
      processMap_.put("getNodeStatus", new getNodeStatus());
      processMap_.put("time", new time());
      processMap_.put("getClass", new getClass());
      processMap_.put("classUpdate", new classUpdate());
      processMap_.put("getResource", new getResource());
      processMap_.put("resourceUpdate", new resourceUpdate());
      processMap_.put("getProperties", new getProperties());
      processMap_.put("getProperty", new getProperty());
      processMap_.put("setProperty", new setProperty());
      processMap_.put("getContest", new getContest());
      processMap_.put("addContest", new addContest());
      processMap_.put("removeContest", new removeContest());
      processMap_.put("propertyUpdate", new propertyUpdate());
      processMap_.put("contestUpdate", new contestUpdate());
      processMap_.put("logEvent", new logEvent());
      processMap_.put("logSubscribe", new logSubscribe());
      processMap_.put("logUnsubscribe", new logUnsubscribe());
    }

    protected static interface ProcessFunction {
      public void process(int seqid, TProtocol iprot, TProtocol oprot) throws TException;
    }

    private Iface iface_;
    protected final HashMap<String,ProcessFunction> processMap_ = new HashMap<String,ProcessFunction>();

    public boolean process(TProtocol iprot, TProtocol oprot) throws TException
    {
      TMessage msg = iprot.readMessageBegin();
      ProcessFunction fn = processMap_.get(msg.name);
      if (fn == null) {
        TProtocolUtil.skip(iprot, TType.STRUCT);
        iprot.readMessageEnd();
        TApplicationException x = new TApplicationException(TApplicationException.UNKNOWN_METHOD, "Invalid method name: '"+msg.name+"'");
        oprot.writeMessageBegin(new TMessage(msg.name, TMessageType.EXCEPTION, msg.seqid));
        x.write(oprot);
        oprot.writeMessageEnd();
        oprot.getTransport().flush();
        return true;
      }
      fn.process(msg.seqid, iprot, oprot);
      return true;
    }

    private class getNodeId implements ProcessFunction {
      public void process(int seqid, TProtocol iprot, TProtocol oprot) throws TException
      {
        getNodeId_args args = new getNodeId_args();
        args.read(iprot);
        iprot.readMessageEnd();
        getNodeId_result result = new getNodeId_result();
        result.success = iface_.getNodeId();
        oprot.writeMessageBegin(new TMessage("getNodeId", TMessageType.REPLY, seqid));
        result.write(oprot);
        oprot.writeMessageEnd();
        oprot.getTransport().flush();
      }

    }

    private class attach implements ProcessFunction {
      public void process(int seqid, TProtocol iprot, TProtocol oprot) throws TException
      {
        attach_args args = new attach_args();
        args.read(iprot);
        iprot.readMessageEnd();
        attach_result result = new attach_result();
        iface_.attach(args.node);
        oprot.writeMessageBegin(new TMessage("attach", TMessageType.REPLY, seqid));
        result.write(oprot);
        oprot.writeMessageEnd();
        oprot.getTransport().flush();
      }

    }

    private class detach implements ProcessFunction {
      public void process(int seqid, TProtocol iprot, TProtocol oprot) throws TException
      {
        detach_args args = new detach_args();
        args.read(iprot);
        iprot.readMessageEnd();
        detach_result result = new detach_result();
        iface_.detach();
        oprot.writeMessageBegin(new TMessage("detach", TMessageType.REPLY, seqid));
        result.write(oprot);
        oprot.writeMessageEnd();
        oprot.getTransport().flush();
      }

    }

    private class addNode implements ProcessFunction {
      public void process(int seqid, TProtocol iprot, TProtocol oprot) throws TException
      {
        addNode_args args = new addNode_args();
        args.read(iprot);
        iprot.readMessageEnd();
        addNode_result result = new addNode_result();
        iface_.addNode(args.node);
        oprot.writeMessageBegin(new TMessage("addNode", TMessageType.REPLY, seqid));
        result.write(oprot);
        oprot.writeMessageEnd();
        oprot.getTransport().flush();
      }

    }

    private class removeNode implements ProcessFunction {
      public void process(int seqid, TProtocol iprot, TProtocol oprot) throws TException
      {
        removeNode_args args = new removeNode_args();
        args.read(iprot);
        iprot.readMessageEnd();
        removeNode_result result = new removeNode_result();
        iface_.removeNode(args.node);
        oprot.writeMessageBegin(new TMessage("removeNode", TMessageType.REPLY, seqid));
        result.write(oprot);
        oprot.writeMessageEnd();
        oprot.getTransport().flush();
      }

    }

    private class getNodes implements ProcessFunction {
      public void process(int seqid, TProtocol iprot, TProtocol oprot) throws TException
      {
        getNodes_args args = new getNodes_args();
        args.read(iprot);
        iprot.readMessageEnd();
        getNodes_result result = new getNodes_result();
        result.success = iface_.getNodes();
        oprot.writeMessageBegin(new TMessage("getNodes", TMessageType.REPLY, seqid));
        result.write(oprot);
        oprot.writeMessageEnd();
        oprot.getTransport().flush();
      }

    }

    private class getNodeStatus implements ProcessFunction {
      public void process(int seqid, TProtocol iprot, TProtocol oprot) throws TException
      {
        getNodeStatus_args args = new getNodeStatus_args();
        args.read(iprot);
        iprot.readMessageEnd();
        getNodeStatus_result result = new getNodeStatus_result();
        result.success = iface_.getNodeStatus();
        oprot.writeMessageBegin(new TMessage("getNodeStatus", TMessageType.REPLY, seqid));
        result.write(oprot);
        oprot.writeMessageEnd();
        oprot.getTransport().flush();
      }

    }

    private class time implements ProcessFunction {
      public void process(int seqid, TProtocol iprot, TProtocol oprot) throws TException
      {
        time_args args = new time_args();
        args.read(iprot);
        iprot.readMessageEnd();
        time_result result = new time_result();
        result.success = iface_.time();
        result.setSuccessIsSet(true);
        oprot.writeMessageBegin(new TMessage("time", TMessageType.REPLY, seqid));
        result.write(oprot);
        oprot.writeMessageEnd();
        oprot.getTransport().flush();
      }

    }

    private class getClass implements ProcessFunction {
      public void process(int seqid, TProtocol iprot, TProtocol oprot) throws TException
      {
        getClass_args args = new getClass_args();
        args.read(iprot);
        iprot.readMessageEnd();
        getClass_result result = new getClass_result();
        result.success = iface_.getClass(args.className);
        oprot.writeMessageBegin(new TMessage("getClass", TMessageType.REPLY, seqid));
        result.write(oprot);
        oprot.writeMessageEnd();
        oprot.getTransport().flush();
      }

    }

    private class classUpdate implements ProcessFunction {
      public void process(int seqid, TProtocol iprot, TProtocol oprot) throws TException
      {
        classUpdate_args args = new classUpdate_args();
        args.read(iprot);
        iprot.readMessageEnd();
        iface_.classUpdate(args.className);
        return;
      }
    }

    private class getResource implements ProcessFunction {
      public void process(int seqid, TProtocol iprot, TProtocol oprot) throws TException
      {
        getResource_args args = new getResource_args();
        args.read(iprot);
        iprot.readMessageEnd();
        getResource_result result = new getResource_result();
        result.success = iface_.getResource(args.resourceName);
        oprot.writeMessageBegin(new TMessage("getResource", TMessageType.REPLY, seqid));
        result.write(oprot);
        oprot.writeMessageEnd();
        oprot.getTransport().flush();
      }

    }

    private class resourceUpdate implements ProcessFunction {
      public void process(int seqid, TProtocol iprot, TProtocol oprot) throws TException
      {
        resourceUpdate_args args = new resourceUpdate_args();
        args.read(iprot);
        iprot.readMessageEnd();
        iface_.resourceUpdate(args.resourceName);
        return;
      }
    }

    private class getProperties implements ProcessFunction {
      public void process(int seqid, TProtocol iprot, TProtocol oprot) throws TException
      {
        getProperties_args args = new getProperties_args();
        args.read(iprot);
        iprot.readMessageEnd();
        getProperties_result result = new getProperties_result();
        result.success = iface_.getProperties();
        oprot.writeMessageBegin(new TMessage("getProperties", TMessageType.REPLY, seqid));
        result.write(oprot);
        oprot.writeMessageEnd();
        oprot.getTransport().flush();
      }

    }

    private class getProperty implements ProcessFunction {
      public void process(int seqid, TProtocol iprot, TProtocol oprot) throws TException
      {
        getProperty_args args = new getProperty_args();
        args.read(iprot);
        iprot.readMessageEnd();
        getProperty_result result = new getProperty_result();
        result.success = iface_.getProperty(args.key);
        oprot.writeMessageBegin(new TMessage("getProperty", TMessageType.REPLY, seqid));
        result.write(oprot);
        oprot.writeMessageEnd();
        oprot.getTransport().flush();
      }

    }

    private class setProperty implements ProcessFunction {
      public void process(int seqid, TProtocol iprot, TProtocol oprot) throws TException
      {
        setProperty_args args = new setProperty_args();
        args.read(iprot);
        iprot.readMessageEnd();
        setProperty_result result = new setProperty_result();
        iface_.setProperty(args.key, args.value);
        oprot.writeMessageBegin(new TMessage("setProperty", TMessageType.REPLY, seqid));
        result.write(oprot);
        oprot.writeMessageEnd();
        oprot.getTransport().flush();
      }

    }

    private class getContest implements ProcessFunction {
      public void process(int seqid, TProtocol iprot, TProtocol oprot) throws TException
      {
        getContest_args args = new getContest_args();
        args.read(iprot);
        iprot.readMessageEnd();
        getContest_result result = new getContest_result();
        result.success = iface_.getContest(args.contest);
        oprot.writeMessageBegin(new TMessage("getContest", TMessageType.REPLY, seqid));
        result.write(oprot);
        oprot.writeMessageEnd();
        oprot.getTransport().flush();
      }

    }

    private class addContest implements ProcessFunction {
      public void process(int seqid, TProtocol iprot, TProtocol oprot) throws TException
      {
        addContest_args args = new addContest_args();
        args.read(iprot);
        iprot.readMessageEnd();
        addContest_result result = new addContest_result();
        iface_.addContest(args.contest);
        oprot.writeMessageBegin(new TMessage("addContest", TMessageType.REPLY, seqid));
        result.write(oprot);
        oprot.writeMessageEnd();
        oprot.getTransport().flush();
      }

    }

    private class removeContest implements ProcessFunction {
      public void process(int seqid, TProtocol iprot, TProtocol oprot) throws TException
      {
        removeContest_args args = new removeContest_args();
        args.read(iprot);
        iprot.readMessageEnd();
        removeContest_result result = new removeContest_result();
        iface_.removeContest(args.contest);
        oprot.writeMessageBegin(new TMessage("removeContest", TMessageType.REPLY, seqid));
        result.write(oprot);
        oprot.writeMessageEnd();
        oprot.getTransport().flush();
      }

    }

    private class propertyUpdate implements ProcessFunction {
      public void process(int seqid, TProtocol iprot, TProtocol oprot) throws TException
      {
        propertyUpdate_args args = new propertyUpdate_args();
        args.read(iprot);
        iprot.readMessageEnd();
        iface_.propertyUpdate(args.event);
        return;
      }
    }

    private class contestUpdate implements ProcessFunction {
      public void process(int seqid, TProtocol iprot, TProtocol oprot) throws TException
      {
        contestUpdate_args args = new contestUpdate_args();
        args.read(iprot);
        iprot.readMessageEnd();
        iface_.contestUpdate(args.contest, args.event);
        return;
      }
    }

    private class logEvent implements ProcessFunction {
      public void process(int seqid, TProtocol iprot, TProtocol oprot) throws TException
      {
        logEvent_args args = new logEvent_args();
        args.read(iprot);
        iprot.readMessageEnd();
        iface_.logEvent(args.event);
        return;
      }
    }

    private class logSubscribe implements ProcessFunction {
      public void process(int seqid, TProtocol iprot, TProtocol oprot) throws TException
      {
        logSubscribe_args args = new logSubscribe_args();
        args.read(iprot);
        iprot.readMessageEnd();
        iface_.logSubscribe(args.template);
        return;
      }
    }

    private class logUnsubscribe implements ProcessFunction {
      public void process(int seqid, TProtocol iprot, TProtocol oprot) throws TException
      {
        logUnsubscribe_args args = new logUnsubscribe_args();
        args.read(iprot);
        iprot.readMessageEnd();
        iface_.logUnsubscribe(args.template);
        return;
      }
    }

  }

  public static class getNodeId_args implements TBase, java.io.Serializable, Cloneable, Comparable<getNodeId_args>   {
    private static final TStruct STRUCT_DESC = new TStruct("getNodeId_args");

    public static final Map<Integer, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new HashMap<Integer, FieldMetaData>() {{
    }});

    static {
      FieldMetaData.addStructMetaDataMap(getNodeId_args.class, metaDataMap);
    }

    public static final Map<String, Integer> fieldNameMap = Collections.unmodifiableMap(new HashMap<String, Integer>() {{
    }});

    public getNodeId_args() {
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public getNodeId_args(getNodeId_args other) {
    }

    public getNodeId_args deepCopy() {
      return new getNodeId_args(this);
    }

    @Deprecated
    public getNodeId_args clone() {
      return new getNodeId_args(this);
    }

    public void setFieldValue(int fieldID, Object value) {
      switch (fieldID) {
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    public Object getFieldValue(int fieldID) {
      switch (fieldID) {
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    // Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise
    public boolean isSet(int fieldID) {
      switch (fieldID) {
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof getNodeId_args)
        return this.equals((getNodeId_args)that);
      return false;
    }

    public boolean equals(getNodeId_args that) {
      if (that == null)
        return false;

      return true;
    }

    @Override
    public int hashCode() {
      return 0;
    }

    public int compareTo(getNodeId_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      getNodeId_args typedOther = (getNodeId_args)other;

      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id)
        {
          default:
            TProtocolUtil.skip(iprot, field.type);
            break;
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();


      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      validate();

      oprot.writeStructBegin(STRUCT_DESC);
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("getNodeId_args(");
      boolean first = true;

      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
      // check that fields of type enum have valid values
    }

  }

  public static class getNodeId_result implements TBase, java.io.Serializable, Cloneable, Comparable<getNodeId_result>   {
    private static final TStruct STRUCT_DESC = new TStruct("getNodeId_result");
    private static final TField SUCCESS_FIELD_DESC = new TField("success", TType.STRUCT, (short)0);

    public NodeId success;
    public static final int SUCCESS = 0;

    // isset id assignments

    public static final Map<Integer, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new HashMap<Integer, FieldMetaData>() {{
      put(SUCCESS, new FieldMetaData("success", TFieldRequirementType.DEFAULT, 
          new StructMetaData(TType.STRUCT, NodeId.class)));
    }});

    static {
      FieldMetaData.addStructMetaDataMap(getNodeId_result.class, metaDataMap);
    }

    public static final Map<String, Integer> fieldNameMap = Collections.unmodifiableMap(new HashMap<String, Integer>() {{
      put("success", new Integer(SUCCESS));
    }});

    public getNodeId_result() {
    }

    public getNodeId_result(
      NodeId success)
    {
      this();
      this.success = success;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public getNodeId_result(getNodeId_result other) {
      if (other.isSetSuccess()) {
        this.success = new NodeId(other.success);
      }
    }

    public getNodeId_result deepCopy() {
      return new getNodeId_result(this);
    }

    @Deprecated
    public getNodeId_result clone() {
      return new getNodeId_result(this);
    }

    public NodeId getSuccess() {
      return this.success;
    }

    public getNodeId_result setSuccess(NodeId success) {
      this.success = success;
      return this;
    }

    public void unsetSuccess() {
      this.success = null;
    }

    // Returns true if field success is set (has been asigned a value) and false otherwise
    public boolean isSetSuccess() {
      return this.success != null;
    }

    public void setSuccessIsSet(boolean value) {
      if (!value) {
        this.success = null;
      }
    }

    public void setFieldValue(int fieldID, Object value) {
      switch (fieldID) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((NodeId)value);
        }
        break;

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    public Object getFieldValue(int fieldID) {
      switch (fieldID) {
      case SUCCESS:
        return getSuccess();

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    // Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise
    public boolean isSet(int fieldID) {
      switch (fieldID) {
      case SUCCESS:
        return isSetSuccess();
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof getNodeId_result)
        return this.equals((getNodeId_result)that);
      return false;
    }

    public boolean equals(getNodeId_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true && this.isSetSuccess();
      boolean that_present_success = true && that.isSetSuccess();
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (!this.success.equals(that.success))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      return 0;
    }

    public int compareTo(getNodeId_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      getNodeId_result typedOther = (getNodeId_result)other;

      lastComparison = Boolean.valueOf(isSetSuccess()).compareTo(isSetSuccess());
      if (lastComparison != 0) {
        return lastComparison;
      }
      lastComparison = TBaseHelper.compareTo(success, typedOther.success);
      if (lastComparison != 0) {
        return lastComparison;
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id)
        {
          case SUCCESS:
            if (field.type == TType.STRUCT) {
              this.success = new NodeId();
              this.success.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
            break;
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();


      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      oprot.writeStructBegin(STRUCT_DESC);

      if (this.isSetSuccess()) {
        oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
        this.success.write(oprot);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("getNodeId_result(");
      boolean first = true;

      sb.append("success:");
      if (this.success == null) {
        sb.append("null");
      } else {
        sb.append(this.success);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
      // check that fields of type enum have valid values
    }

  }

  public static class attach_args implements TBase, java.io.Serializable, Cloneable, Comparable<attach_args>   {
    private static final TStruct STRUCT_DESC = new TStruct("attach_args");
    private static final TField NODE_FIELD_DESC = new TField("node", TType.STRUCT, (short)1);

    public NodeId node;
    public static final int NODE = 1;

    // isset id assignments

    public static final Map<Integer, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new HashMap<Integer, FieldMetaData>() {{
      put(NODE, new FieldMetaData("node", TFieldRequirementType.DEFAULT, 
          new StructMetaData(TType.STRUCT, NodeId.class)));
    }});

    static {
      FieldMetaData.addStructMetaDataMap(attach_args.class, metaDataMap);
    }

    public static final Map<String, Integer> fieldNameMap = Collections.unmodifiableMap(new HashMap<String, Integer>() {{
      put("node", new Integer(NODE));
    }});

    public attach_args() {
    }

    public attach_args(
      NodeId node)
    {
      this();
      this.node = node;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public attach_args(attach_args other) {
      if (other.isSetNode()) {
        this.node = new NodeId(other.node);
      }
    }

    public attach_args deepCopy() {
      return new attach_args(this);
    }

    @Deprecated
    public attach_args clone() {
      return new attach_args(this);
    }

    public NodeId getNode() {
      return this.node;
    }

    public attach_args setNode(NodeId node) {
      this.node = node;
      return this;
    }

    public void unsetNode() {
      this.node = null;
    }

    // Returns true if field node is set (has been asigned a value) and false otherwise
    public boolean isSetNode() {
      return this.node != null;
    }

    public void setNodeIsSet(boolean value) {
      if (!value) {
        this.node = null;
      }
    }

    public void setFieldValue(int fieldID, Object value) {
      switch (fieldID) {
      case NODE:
        if (value == null) {
          unsetNode();
        } else {
          setNode((NodeId)value);
        }
        break;

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    public Object getFieldValue(int fieldID) {
      switch (fieldID) {
      case NODE:
        return getNode();

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    // Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise
    public boolean isSet(int fieldID) {
      switch (fieldID) {
      case NODE:
        return isSetNode();
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof attach_args)
        return this.equals((attach_args)that);
      return false;
    }

    public boolean equals(attach_args that) {
      if (that == null)
        return false;

      boolean this_present_node = true && this.isSetNode();
      boolean that_present_node = true && that.isSetNode();
      if (this_present_node || that_present_node) {
        if (!(this_present_node && that_present_node))
          return false;
        if (!this.node.equals(that.node))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      return 0;
    }

    public int compareTo(attach_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      attach_args typedOther = (attach_args)other;

      lastComparison = Boolean.valueOf(isSetNode()).compareTo(isSetNode());
      if (lastComparison != 0) {
        return lastComparison;
      }
      lastComparison = TBaseHelper.compareTo(node, typedOther.node);
      if (lastComparison != 0) {
        return lastComparison;
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id)
        {
          case NODE:
            if (field.type == TType.STRUCT) {
              this.node = new NodeId();
              this.node.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
            break;
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();


      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      validate();

      oprot.writeStructBegin(STRUCT_DESC);
      if (this.node != null) {
        oprot.writeFieldBegin(NODE_FIELD_DESC);
        this.node.write(oprot);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("attach_args(");
      boolean first = true;

      sb.append("node:");
      if (this.node == null) {
        sb.append("null");
      } else {
        sb.append(this.node);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
      // check that fields of type enum have valid values
    }

  }

  public static class attach_result implements TBase, java.io.Serializable, Cloneable, Comparable<attach_result>   {
    private static final TStruct STRUCT_DESC = new TStruct("attach_result");

    public static final Map<Integer, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new HashMap<Integer, FieldMetaData>() {{
    }});

    static {
      FieldMetaData.addStructMetaDataMap(attach_result.class, metaDataMap);
    }

    public static final Map<String, Integer> fieldNameMap = Collections.unmodifiableMap(new HashMap<String, Integer>() {{
    }});

    public attach_result() {
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public attach_result(attach_result other) {
    }

    public attach_result deepCopy() {
      return new attach_result(this);
    }

    @Deprecated
    public attach_result clone() {
      return new attach_result(this);
    }

    public void setFieldValue(int fieldID, Object value) {
      switch (fieldID) {
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    public Object getFieldValue(int fieldID) {
      switch (fieldID) {
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    // Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise
    public boolean isSet(int fieldID) {
      switch (fieldID) {
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof attach_result)
        return this.equals((attach_result)that);
      return false;
    }

    public boolean equals(attach_result that) {
      if (that == null)
        return false;

      return true;
    }

    @Override
    public int hashCode() {
      return 0;
    }

    public int compareTo(attach_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      attach_result typedOther = (attach_result)other;

      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id)
        {
          default:
            TProtocolUtil.skip(iprot, field.type);
            break;
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();


      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      oprot.writeStructBegin(STRUCT_DESC);

      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("attach_result(");
      boolean first = true;

      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
      // check that fields of type enum have valid values
    }

  }

  public static class detach_args implements TBase, java.io.Serializable, Cloneable, Comparable<detach_args>   {
    private static final TStruct STRUCT_DESC = new TStruct("detach_args");

    public static final Map<Integer, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new HashMap<Integer, FieldMetaData>() {{
    }});

    static {
      FieldMetaData.addStructMetaDataMap(detach_args.class, metaDataMap);
    }

    public static final Map<String, Integer> fieldNameMap = Collections.unmodifiableMap(new HashMap<String, Integer>() {{
    }});

    public detach_args() {
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public detach_args(detach_args other) {
    }

    public detach_args deepCopy() {
      return new detach_args(this);
    }

    @Deprecated
    public detach_args clone() {
      return new detach_args(this);
    }

    public void setFieldValue(int fieldID, Object value) {
      switch (fieldID) {
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    public Object getFieldValue(int fieldID) {
      switch (fieldID) {
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    // Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise
    public boolean isSet(int fieldID) {
      switch (fieldID) {
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof detach_args)
        return this.equals((detach_args)that);
      return false;
    }

    public boolean equals(detach_args that) {
      if (that == null)
        return false;

      return true;
    }

    @Override
    public int hashCode() {
      return 0;
    }

    public int compareTo(detach_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      detach_args typedOther = (detach_args)other;

      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id)
        {
          default:
            TProtocolUtil.skip(iprot, field.type);
            break;
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();


      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      validate();

      oprot.writeStructBegin(STRUCT_DESC);
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("detach_args(");
      boolean first = true;

      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
      // check that fields of type enum have valid values
    }

  }

  public static class detach_result implements TBase, java.io.Serializable, Cloneable, Comparable<detach_result>   {
    private static final TStruct STRUCT_DESC = new TStruct("detach_result");

    public static final Map<Integer, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new HashMap<Integer, FieldMetaData>() {{
    }});

    static {
      FieldMetaData.addStructMetaDataMap(detach_result.class, metaDataMap);
    }

    public static final Map<String, Integer> fieldNameMap = Collections.unmodifiableMap(new HashMap<String, Integer>() {{
    }});

    public detach_result() {
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public detach_result(detach_result other) {
    }

    public detach_result deepCopy() {
      return new detach_result(this);
    }

    @Deprecated
    public detach_result clone() {
      return new detach_result(this);
    }

    public void setFieldValue(int fieldID, Object value) {
      switch (fieldID) {
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    public Object getFieldValue(int fieldID) {
      switch (fieldID) {
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    // Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise
    public boolean isSet(int fieldID) {
      switch (fieldID) {
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof detach_result)
        return this.equals((detach_result)that);
      return false;
    }

    public boolean equals(detach_result that) {
      if (that == null)
        return false;

      return true;
    }

    @Override
    public int hashCode() {
      return 0;
    }

    public int compareTo(detach_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      detach_result typedOther = (detach_result)other;

      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id)
        {
          default:
            TProtocolUtil.skip(iprot, field.type);
            break;
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();


      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      oprot.writeStructBegin(STRUCT_DESC);

      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("detach_result(");
      boolean first = true;

      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
      // check that fields of type enum have valid values
    }

  }

  public static class addNode_args implements TBase, java.io.Serializable, Cloneable, Comparable<addNode_args>   {
    private static final TStruct STRUCT_DESC = new TStruct("addNode_args");
    private static final TField NODE_FIELD_DESC = new TField("node", TType.STRUCT, (short)1);

    public NodeId node;
    public static final int NODE = 1;

    // isset id assignments

    public static final Map<Integer, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new HashMap<Integer, FieldMetaData>() {{
      put(NODE, new FieldMetaData("node", TFieldRequirementType.DEFAULT, 
          new StructMetaData(TType.STRUCT, NodeId.class)));
    }});

    static {
      FieldMetaData.addStructMetaDataMap(addNode_args.class, metaDataMap);
    }

    public static final Map<String, Integer> fieldNameMap = Collections.unmodifiableMap(new HashMap<String, Integer>() {{
      put("node", new Integer(NODE));
    }});

    public addNode_args() {
    }

    public addNode_args(
      NodeId node)
    {
      this();
      this.node = node;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public addNode_args(addNode_args other) {
      if (other.isSetNode()) {
        this.node = new NodeId(other.node);
      }
    }

    public addNode_args deepCopy() {
      return new addNode_args(this);
    }

    @Deprecated
    public addNode_args clone() {
      return new addNode_args(this);
    }

    public NodeId getNode() {
      return this.node;
    }

    public addNode_args setNode(NodeId node) {
      this.node = node;
      return this;
    }

    public void unsetNode() {
      this.node = null;
    }

    // Returns true if field node is set (has been asigned a value) and false otherwise
    public boolean isSetNode() {
      return this.node != null;
    }

    public void setNodeIsSet(boolean value) {
      if (!value) {
        this.node = null;
      }
    }

    public void setFieldValue(int fieldID, Object value) {
      switch (fieldID) {
      case NODE:
        if (value == null) {
          unsetNode();
        } else {
          setNode((NodeId)value);
        }
        break;

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    public Object getFieldValue(int fieldID) {
      switch (fieldID) {
      case NODE:
        return getNode();

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    // Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise
    public boolean isSet(int fieldID) {
      switch (fieldID) {
      case NODE:
        return isSetNode();
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof addNode_args)
        return this.equals((addNode_args)that);
      return false;
    }

    public boolean equals(addNode_args that) {
      if (that == null)
        return false;

      boolean this_present_node = true && this.isSetNode();
      boolean that_present_node = true && that.isSetNode();
      if (this_present_node || that_present_node) {
        if (!(this_present_node && that_present_node))
          return false;
        if (!this.node.equals(that.node))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      return 0;
    }

    public int compareTo(addNode_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      addNode_args typedOther = (addNode_args)other;

      lastComparison = Boolean.valueOf(isSetNode()).compareTo(isSetNode());
      if (lastComparison != 0) {
        return lastComparison;
      }
      lastComparison = TBaseHelper.compareTo(node, typedOther.node);
      if (lastComparison != 0) {
        return lastComparison;
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id)
        {
          case NODE:
            if (field.type == TType.STRUCT) {
              this.node = new NodeId();
              this.node.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
            break;
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();


      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      validate();

      oprot.writeStructBegin(STRUCT_DESC);
      if (this.node != null) {
        oprot.writeFieldBegin(NODE_FIELD_DESC);
        this.node.write(oprot);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("addNode_args(");
      boolean first = true;

      sb.append("node:");
      if (this.node == null) {
        sb.append("null");
      } else {
        sb.append(this.node);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
      // check that fields of type enum have valid values
    }

  }

  public static class addNode_result implements TBase, java.io.Serializable, Cloneable, Comparable<addNode_result>   {
    private static final TStruct STRUCT_DESC = new TStruct("addNode_result");

    public static final Map<Integer, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new HashMap<Integer, FieldMetaData>() {{
    }});

    static {
      FieldMetaData.addStructMetaDataMap(addNode_result.class, metaDataMap);
    }

    public static final Map<String, Integer> fieldNameMap = Collections.unmodifiableMap(new HashMap<String, Integer>() {{
    }});

    public addNode_result() {
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public addNode_result(addNode_result other) {
    }

    public addNode_result deepCopy() {
      return new addNode_result(this);
    }

    @Deprecated
    public addNode_result clone() {
      return new addNode_result(this);
    }

    public void setFieldValue(int fieldID, Object value) {
      switch (fieldID) {
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    public Object getFieldValue(int fieldID) {
      switch (fieldID) {
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    // Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise
    public boolean isSet(int fieldID) {
      switch (fieldID) {
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof addNode_result)
        return this.equals((addNode_result)that);
      return false;
    }

    public boolean equals(addNode_result that) {
      if (that == null)
        return false;

      return true;
    }

    @Override
    public int hashCode() {
      return 0;
    }

    public int compareTo(addNode_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      addNode_result typedOther = (addNode_result)other;

      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id)
        {
          default:
            TProtocolUtil.skip(iprot, field.type);
            break;
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();


      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      oprot.writeStructBegin(STRUCT_DESC);

      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("addNode_result(");
      boolean first = true;

      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
      // check that fields of type enum have valid values
    }

  }

  public static class removeNode_args implements TBase, java.io.Serializable, Cloneable, Comparable<removeNode_args>   {
    private static final TStruct STRUCT_DESC = new TStruct("removeNode_args");
    private static final TField NODE_FIELD_DESC = new TField("node", TType.STRUCT, (short)1);

    public NodeId node;
    public static final int NODE = 1;

    // isset id assignments

    public static final Map<Integer, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new HashMap<Integer, FieldMetaData>() {{
      put(NODE, new FieldMetaData("node", TFieldRequirementType.DEFAULT, 
          new StructMetaData(TType.STRUCT, NodeId.class)));
    }});

    static {
      FieldMetaData.addStructMetaDataMap(removeNode_args.class, metaDataMap);
    }

    public static final Map<String, Integer> fieldNameMap = Collections.unmodifiableMap(new HashMap<String, Integer>() {{
      put("node", new Integer(NODE));
    }});

    public removeNode_args() {
    }

    public removeNode_args(
      NodeId node)
    {
      this();
      this.node = node;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public removeNode_args(removeNode_args other) {
      if (other.isSetNode()) {
        this.node = new NodeId(other.node);
      }
    }

    public removeNode_args deepCopy() {
      return new removeNode_args(this);
    }

    @Deprecated
    public removeNode_args clone() {
      return new removeNode_args(this);
    }

    public NodeId getNode() {
      return this.node;
    }

    public removeNode_args setNode(NodeId node) {
      this.node = node;
      return this;
    }

    public void unsetNode() {
      this.node = null;
    }

    // Returns true if field node is set (has been asigned a value) and false otherwise
    public boolean isSetNode() {
      return this.node != null;
    }

    public void setNodeIsSet(boolean value) {
      if (!value) {
        this.node = null;
      }
    }

    public void setFieldValue(int fieldID, Object value) {
      switch (fieldID) {
      case NODE:
        if (value == null) {
          unsetNode();
        } else {
          setNode((NodeId)value);
        }
        break;

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    public Object getFieldValue(int fieldID) {
      switch (fieldID) {
      case NODE:
        return getNode();

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    // Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise
    public boolean isSet(int fieldID) {
      switch (fieldID) {
      case NODE:
        return isSetNode();
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof removeNode_args)
        return this.equals((removeNode_args)that);
      return false;
    }

    public boolean equals(removeNode_args that) {
      if (that == null)
        return false;

      boolean this_present_node = true && this.isSetNode();
      boolean that_present_node = true && that.isSetNode();
      if (this_present_node || that_present_node) {
        if (!(this_present_node && that_present_node))
          return false;
        if (!this.node.equals(that.node))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      return 0;
    }

    public int compareTo(removeNode_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      removeNode_args typedOther = (removeNode_args)other;

      lastComparison = Boolean.valueOf(isSetNode()).compareTo(isSetNode());
      if (lastComparison != 0) {
        return lastComparison;
      }
      lastComparison = TBaseHelper.compareTo(node, typedOther.node);
      if (lastComparison != 0) {
        return lastComparison;
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id)
        {
          case NODE:
            if (field.type == TType.STRUCT) {
              this.node = new NodeId();
              this.node.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
            break;
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();


      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      validate();

      oprot.writeStructBegin(STRUCT_DESC);
      if (this.node != null) {
        oprot.writeFieldBegin(NODE_FIELD_DESC);
        this.node.write(oprot);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("removeNode_args(");
      boolean first = true;

      sb.append("node:");
      if (this.node == null) {
        sb.append("null");
      } else {
        sb.append(this.node);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
      // check that fields of type enum have valid values
    }

  }

  public static class removeNode_result implements TBase, java.io.Serializable, Cloneable, Comparable<removeNode_result>   {
    private static final TStruct STRUCT_DESC = new TStruct("removeNode_result");

    public static final Map<Integer, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new HashMap<Integer, FieldMetaData>() {{
    }});

    static {
      FieldMetaData.addStructMetaDataMap(removeNode_result.class, metaDataMap);
    }

    public static final Map<String, Integer> fieldNameMap = Collections.unmodifiableMap(new HashMap<String, Integer>() {{
    }});

    public removeNode_result() {
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public removeNode_result(removeNode_result other) {
    }

    public removeNode_result deepCopy() {
      return new removeNode_result(this);
    }

    @Deprecated
    public removeNode_result clone() {
      return new removeNode_result(this);
    }

    public void setFieldValue(int fieldID, Object value) {
      switch (fieldID) {
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    public Object getFieldValue(int fieldID) {
      switch (fieldID) {
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    // Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise
    public boolean isSet(int fieldID) {
      switch (fieldID) {
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof removeNode_result)
        return this.equals((removeNode_result)that);
      return false;
    }

    public boolean equals(removeNode_result that) {
      if (that == null)
        return false;

      return true;
    }

    @Override
    public int hashCode() {
      return 0;
    }

    public int compareTo(removeNode_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      removeNode_result typedOther = (removeNode_result)other;

      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id)
        {
          default:
            TProtocolUtil.skip(iprot, field.type);
            break;
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();


      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      oprot.writeStructBegin(STRUCT_DESC);

      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("removeNode_result(");
      boolean first = true;

      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
      // check that fields of type enum have valid values
    }

  }

  public static class getNodes_args implements TBase, java.io.Serializable, Cloneable, Comparable<getNodes_args>   {
    private static final TStruct STRUCT_DESC = new TStruct("getNodes_args");

    public static final Map<Integer, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new HashMap<Integer, FieldMetaData>() {{
    }});

    static {
      FieldMetaData.addStructMetaDataMap(getNodes_args.class, metaDataMap);
    }

    public static final Map<String, Integer> fieldNameMap = Collections.unmodifiableMap(new HashMap<String, Integer>() {{
    }});

    public getNodes_args() {
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public getNodes_args(getNodes_args other) {
    }

    public getNodes_args deepCopy() {
      return new getNodes_args(this);
    }

    @Deprecated
    public getNodes_args clone() {
      return new getNodes_args(this);
    }

    public void setFieldValue(int fieldID, Object value) {
      switch (fieldID) {
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    public Object getFieldValue(int fieldID) {
      switch (fieldID) {
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    // Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise
    public boolean isSet(int fieldID) {
      switch (fieldID) {
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof getNodes_args)
        return this.equals((getNodes_args)that);
      return false;
    }

    public boolean equals(getNodes_args that) {
      if (that == null)
        return false;

      return true;
    }

    @Override
    public int hashCode() {
      return 0;
    }

    public int compareTo(getNodes_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      getNodes_args typedOther = (getNodes_args)other;

      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id)
        {
          default:
            TProtocolUtil.skip(iprot, field.type);
            break;
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();


      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      validate();

      oprot.writeStructBegin(STRUCT_DESC);
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("getNodes_args(");
      boolean first = true;

      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
      // check that fields of type enum have valid values
    }

  }

  public static class getNodes_result implements TBase, java.io.Serializable, Cloneable, Comparable<getNodes_result>   {
    private static final TStruct STRUCT_DESC = new TStruct("getNodes_result");
    private static final TField SUCCESS_FIELD_DESC = new TField("success", TType.LIST, (short)0);

    public List<NodeId> success;
    public static final int SUCCESS = 0;

    // isset id assignments

    public static final Map<Integer, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new HashMap<Integer, FieldMetaData>() {{
      put(SUCCESS, new FieldMetaData("success", TFieldRequirementType.DEFAULT, 
          new ListMetaData(TType.LIST, 
              new StructMetaData(TType.STRUCT, NodeId.class))));
    }});

    static {
      FieldMetaData.addStructMetaDataMap(getNodes_result.class, metaDataMap);
    }

    public static final Map<String, Integer> fieldNameMap = Collections.unmodifiableMap(new HashMap<String, Integer>() {{
      put("success", new Integer(SUCCESS));
    }});

    public getNodes_result() {
    }

    public getNodes_result(
      List<NodeId> success)
    {
      this();
      this.success = success;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public getNodes_result(getNodes_result other) {
      if (other.isSetSuccess()) {
        List<NodeId> __this__success = new ArrayList<NodeId>();
        for (NodeId other_element : other.success) {
          __this__success.add(new NodeId(other_element));
        }
        this.success = __this__success;
      }
    }

    public getNodes_result deepCopy() {
      return new getNodes_result(this);
    }

    @Deprecated
    public getNodes_result clone() {
      return new getNodes_result(this);
    }

    public int getSuccessSize() {
      return (this.success == null) ? 0 : this.success.size();
    }

    public java.util.Iterator<NodeId> getSuccessIterator() {
      return (this.success == null) ? null : this.success.iterator();
    }

    public void addToSuccess(NodeId elem) {
      if (this.success == null) {
        this.success = new ArrayList<NodeId>();
      }
      this.success.add(elem);
    }

    public List<NodeId> getSuccess() {
      return this.success;
    }

    public getNodes_result setSuccess(List<NodeId> success) {
      this.success = success;
      return this;
    }

    public void unsetSuccess() {
      this.success = null;
    }

    // Returns true if field success is set (has been asigned a value) and false otherwise
    public boolean isSetSuccess() {
      return this.success != null;
    }

    public void setSuccessIsSet(boolean value) {
      if (!value) {
        this.success = null;
      }
    }

    public void setFieldValue(int fieldID, Object value) {
      switch (fieldID) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((List<NodeId>)value);
        }
        break;

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    public Object getFieldValue(int fieldID) {
      switch (fieldID) {
      case SUCCESS:
        return getSuccess();

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    // Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise
    public boolean isSet(int fieldID) {
      switch (fieldID) {
      case SUCCESS:
        return isSetSuccess();
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof getNodes_result)
        return this.equals((getNodes_result)that);
      return false;
    }

    public boolean equals(getNodes_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true && this.isSetSuccess();
      boolean that_present_success = true && that.isSetSuccess();
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (!this.success.equals(that.success))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      return 0;
    }

    public int compareTo(getNodes_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      getNodes_result typedOther = (getNodes_result)other;

      lastComparison = Boolean.valueOf(isSetSuccess()).compareTo(isSetSuccess());
      if (lastComparison != 0) {
        return lastComparison;
      }
      lastComparison = TBaseHelper.compareTo(success, typedOther.success);
      if (lastComparison != 0) {
        return lastComparison;
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id)
        {
          case SUCCESS:
            if (field.type == TType.LIST) {
              {
                TList _list13 = iprot.readListBegin();
                this.success = new ArrayList<NodeId>(_list13.size);
                for (int _i14 = 0; _i14 < _list13.size; ++_i14)
                {
                  NodeId _elem15;
                  _elem15 = new NodeId();
                  _elem15.read(iprot);
                  this.success.add(_elem15);
                }
                iprot.readListEnd();
              }
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
            break;
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();


      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      oprot.writeStructBegin(STRUCT_DESC);

      if (this.isSetSuccess()) {
        oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
        {
          oprot.writeListBegin(new TList(TType.STRUCT, this.success.size()));
          for (NodeId _iter16 : this.success)
          {
            _iter16.write(oprot);
          }
          oprot.writeListEnd();
        }
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("getNodes_result(");
      boolean first = true;

      sb.append("success:");
      if (this.success == null) {
        sb.append("null");
      } else {
        sb.append(this.success);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
      // check that fields of type enum have valid values
    }

  }

  public static class getNodeStatus_args implements TBase, java.io.Serializable, Cloneable, Comparable<getNodeStatus_args>   {
    private static final TStruct STRUCT_DESC = new TStruct("getNodeStatus_args");

    public static final Map<Integer, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new HashMap<Integer, FieldMetaData>() {{
    }});

    static {
      FieldMetaData.addStructMetaDataMap(getNodeStatus_args.class, metaDataMap);
    }

    public static final Map<String, Integer> fieldNameMap = Collections.unmodifiableMap(new HashMap<String, Integer>() {{
    }});

    public getNodeStatus_args() {
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public getNodeStatus_args(getNodeStatus_args other) {
    }

    public getNodeStatus_args deepCopy() {
      return new getNodeStatus_args(this);
    }

    @Deprecated
    public getNodeStatus_args clone() {
      return new getNodeStatus_args(this);
    }

    public void setFieldValue(int fieldID, Object value) {
      switch (fieldID) {
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    public Object getFieldValue(int fieldID) {
      switch (fieldID) {
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    // Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise
    public boolean isSet(int fieldID) {
      switch (fieldID) {
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof getNodeStatus_args)
        return this.equals((getNodeStatus_args)that);
      return false;
    }

    public boolean equals(getNodeStatus_args that) {
      if (that == null)
        return false;

      return true;
    }

    @Override
    public int hashCode() {
      return 0;
    }

    public int compareTo(getNodeStatus_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      getNodeStatus_args typedOther = (getNodeStatus_args)other;

      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id)
        {
          default:
            TProtocolUtil.skip(iprot, field.type);
            break;
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();


      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      validate();

      oprot.writeStructBegin(STRUCT_DESC);
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("getNodeStatus_args(");
      boolean first = true;

      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
      // check that fields of type enum have valid values
    }

  }

  public static class getNodeStatus_result implements TBase, java.io.Serializable, Cloneable, Comparable<getNodeStatus_result>   {
    private static final TStruct STRUCT_DESC = new TStruct("getNodeStatus_result");
    private static final TField SUCCESS_FIELD_DESC = new TField("success", TType.LIST, (short)0);

    public List<NodeStatus> success;
    public static final int SUCCESS = 0;

    // isset id assignments

    public static final Map<Integer, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new HashMap<Integer, FieldMetaData>() {{
      put(SUCCESS, new FieldMetaData("success", TFieldRequirementType.DEFAULT, 
          new ListMetaData(TType.LIST, 
              new StructMetaData(TType.STRUCT, NodeStatus.class))));
    }});

    static {
      FieldMetaData.addStructMetaDataMap(getNodeStatus_result.class, metaDataMap);
    }

    public static final Map<String, Integer> fieldNameMap = Collections.unmodifiableMap(new HashMap<String, Integer>() {{
      put("success", new Integer(SUCCESS));
    }});

    public getNodeStatus_result() {
    }

    public getNodeStatus_result(
      List<NodeStatus> success)
    {
      this();
      this.success = success;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public getNodeStatus_result(getNodeStatus_result other) {
      if (other.isSetSuccess()) {
        List<NodeStatus> __this__success = new ArrayList<NodeStatus>();
        for (NodeStatus other_element : other.success) {
          __this__success.add(new NodeStatus(other_element));
        }
        this.success = __this__success;
      }
    }

    public getNodeStatus_result deepCopy() {
      return new getNodeStatus_result(this);
    }

    @Deprecated
    public getNodeStatus_result clone() {
      return new getNodeStatus_result(this);
    }

    public int getSuccessSize() {
      return (this.success == null) ? 0 : this.success.size();
    }

    public java.util.Iterator<NodeStatus> getSuccessIterator() {
      return (this.success == null) ? null : this.success.iterator();
    }

    public void addToSuccess(NodeStatus elem) {
      if (this.success == null) {
        this.success = new ArrayList<NodeStatus>();
      }
      this.success.add(elem);
    }

    public List<NodeStatus> getSuccess() {
      return this.success;
    }

    public getNodeStatus_result setSuccess(List<NodeStatus> success) {
      this.success = success;
      return this;
    }

    public void unsetSuccess() {
      this.success = null;
    }

    // Returns true if field success is set (has been asigned a value) and false otherwise
    public boolean isSetSuccess() {
      return this.success != null;
    }

    public void setSuccessIsSet(boolean value) {
      if (!value) {
        this.success = null;
      }
    }

    public void setFieldValue(int fieldID, Object value) {
      switch (fieldID) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((List<NodeStatus>)value);
        }
        break;

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    public Object getFieldValue(int fieldID) {
      switch (fieldID) {
      case SUCCESS:
        return getSuccess();

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    // Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise
    public boolean isSet(int fieldID) {
      switch (fieldID) {
      case SUCCESS:
        return isSetSuccess();
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof getNodeStatus_result)
        return this.equals((getNodeStatus_result)that);
      return false;
    }

    public boolean equals(getNodeStatus_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true && this.isSetSuccess();
      boolean that_present_success = true && that.isSetSuccess();
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (!this.success.equals(that.success))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      return 0;
    }

    public int compareTo(getNodeStatus_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      getNodeStatus_result typedOther = (getNodeStatus_result)other;

      lastComparison = Boolean.valueOf(isSetSuccess()).compareTo(isSetSuccess());
      if (lastComparison != 0) {
        return lastComparison;
      }
      lastComparison = TBaseHelper.compareTo(success, typedOther.success);
      if (lastComparison != 0) {
        return lastComparison;
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id)
        {
          case SUCCESS:
            if (field.type == TType.LIST) {
              {
                TList _list17 = iprot.readListBegin();
                this.success = new ArrayList<NodeStatus>(_list17.size);
                for (int _i18 = 0; _i18 < _list17.size; ++_i18)
                {
                  NodeStatus _elem19;
                  _elem19 = new NodeStatus();
                  _elem19.read(iprot);
                  this.success.add(_elem19);
                }
                iprot.readListEnd();
              }
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
            break;
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();


      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      oprot.writeStructBegin(STRUCT_DESC);

      if (this.isSetSuccess()) {
        oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
        {
          oprot.writeListBegin(new TList(TType.STRUCT, this.success.size()));
          for (NodeStatus _iter20 : this.success)
          {
            _iter20.write(oprot);
          }
          oprot.writeListEnd();
        }
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("getNodeStatus_result(");
      boolean first = true;

      sb.append("success:");
      if (this.success == null) {
        sb.append("null");
      } else {
        sb.append(this.success);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
      // check that fields of type enum have valid values
    }

  }

  public static class time_args implements TBase, java.io.Serializable, Cloneable, Comparable<time_args>   {
    private static final TStruct STRUCT_DESC = new TStruct("time_args");

    public static final Map<Integer, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new HashMap<Integer, FieldMetaData>() {{
    }});

    static {
      FieldMetaData.addStructMetaDataMap(time_args.class, metaDataMap);
    }

    public static final Map<String, Integer> fieldNameMap = Collections.unmodifiableMap(new HashMap<String, Integer>() {{
    }});

    public time_args() {
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public time_args(time_args other) {
    }

    public time_args deepCopy() {
      return new time_args(this);
    }

    @Deprecated
    public time_args clone() {
      return new time_args(this);
    }

    public void setFieldValue(int fieldID, Object value) {
      switch (fieldID) {
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    public Object getFieldValue(int fieldID) {
      switch (fieldID) {
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    // Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise
    public boolean isSet(int fieldID) {
      switch (fieldID) {
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof time_args)
        return this.equals((time_args)that);
      return false;
    }

    public boolean equals(time_args that) {
      if (that == null)
        return false;

      return true;
    }

    @Override
    public int hashCode() {
      return 0;
    }

    public int compareTo(time_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      time_args typedOther = (time_args)other;

      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id)
        {
          default:
            TProtocolUtil.skip(iprot, field.type);
            break;
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();


      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      validate();

      oprot.writeStructBegin(STRUCT_DESC);
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("time_args(");
      boolean first = true;

      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
      // check that fields of type enum have valid values
    }

  }

  public static class time_result implements TBase, java.io.Serializable, Cloneable, Comparable<time_result>   {
    private static final TStruct STRUCT_DESC = new TStruct("time_result");
    private static final TField SUCCESS_FIELD_DESC = new TField("success", TType.I64, (short)0);

    public long success;
    public static final int SUCCESS = 0;

    // isset id assignments
    private static final int __SUCCESS_ISSET_ID = 0;
    private BitSet __isset_bit_vector = new BitSet(1);

    public static final Map<Integer, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new HashMap<Integer, FieldMetaData>() {{
      put(SUCCESS, new FieldMetaData("success", TFieldRequirementType.DEFAULT, 
          new FieldValueMetaData(TType.I64)));
    }});

    static {
      FieldMetaData.addStructMetaDataMap(time_result.class, metaDataMap);
    }

    public static final Map<String, Integer> fieldNameMap = Collections.unmodifiableMap(new HashMap<String, Integer>() {{
      put("success", new Integer(SUCCESS));
    }});

    public time_result() {
    }

    public time_result(
      long success)
    {
      this();
      this.success = success;
      setSuccessIsSet(true);
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public time_result(time_result other) {
      __isset_bit_vector.clear();
      __isset_bit_vector.or(other.__isset_bit_vector);
      this.success = other.success;
    }

    public time_result deepCopy() {
      return new time_result(this);
    }

    @Deprecated
    public time_result clone() {
      return new time_result(this);
    }

    public long getSuccess() {
      return this.success;
    }

    public time_result setSuccess(long success) {
      this.success = success;
      setSuccessIsSet(true);
      return this;
    }

    public void unsetSuccess() {
      __isset_bit_vector.clear(__SUCCESS_ISSET_ID);
    }

    // Returns true if field success is set (has been asigned a value) and false otherwise
    public boolean isSetSuccess() {
      return __isset_bit_vector.get(__SUCCESS_ISSET_ID);
    }

    public void setSuccessIsSet(boolean value) {
      __isset_bit_vector.set(__SUCCESS_ISSET_ID, value);
    }

    public void setFieldValue(int fieldID, Object value) {
      switch (fieldID) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((Long)value);
        }
        break;

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    public Object getFieldValue(int fieldID) {
      switch (fieldID) {
      case SUCCESS:
        return new Long(getSuccess());

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    // Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise
    public boolean isSet(int fieldID) {
      switch (fieldID) {
      case SUCCESS:
        return isSetSuccess();
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof time_result)
        return this.equals((time_result)that);
      return false;
    }

    public boolean equals(time_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true;
      boolean that_present_success = true;
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (this.success != that.success)
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      return 0;
    }

    public int compareTo(time_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      time_result typedOther = (time_result)other;

      lastComparison = Boolean.valueOf(isSetSuccess()).compareTo(isSetSuccess());
      if (lastComparison != 0) {
        return lastComparison;
      }
      lastComparison = TBaseHelper.compareTo(success, typedOther.success);
      if (lastComparison != 0) {
        return lastComparison;
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id)
        {
          case SUCCESS:
            if (field.type == TType.I64) {
              this.success = iprot.readI64();
              setSuccessIsSet(true);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
            break;
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();


      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      oprot.writeStructBegin(STRUCT_DESC);

      if (this.isSetSuccess()) {
        oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
        oprot.writeI64(this.success);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("time_result(");
      boolean first = true;

      sb.append("success:");
      sb.append(this.success);
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
      // check that fields of type enum have valid values
    }

  }

  public static class getClass_args implements TBase, java.io.Serializable, Cloneable, Comparable<getClass_args>   {
    private static final TStruct STRUCT_DESC = new TStruct("getClass_args");
    private static final TField CLASS_NAME_FIELD_DESC = new TField("className", TType.STRING, (short)1);

    public String className;
    public static final int CLASSNAME = 1;

    // isset id assignments

    public static final Map<Integer, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new HashMap<Integer, FieldMetaData>() {{
      put(CLASSNAME, new FieldMetaData("className", TFieldRequirementType.DEFAULT, 
          new FieldValueMetaData(TType.STRING)));
    }});

    static {
      FieldMetaData.addStructMetaDataMap(getClass_args.class, metaDataMap);
    }

    public static final Map<String, Integer> fieldNameMap = Collections.unmodifiableMap(new HashMap<String, Integer>() {{
      put("className", new Integer(CLASSNAME));
    }});

    public getClass_args() {
    }

    public getClass_args(
      String className)
    {
      this();
      this.className = className;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public getClass_args(getClass_args other) {
      if (other.isSetClassName()) {
        this.className = other.className;
      }
    }

    public getClass_args deepCopy() {
      return new getClass_args(this);
    }

    @Deprecated
    public getClass_args clone() {
      return new getClass_args(this);
    }

    public String getClassName() {
      return this.className;
    }

    public getClass_args setClassName(String className) {
      this.className = className;
      return this;
    }

    public void unsetClassName() {
      this.className = null;
    }

    // Returns true if field className is set (has been asigned a value) and false otherwise
    public boolean isSetClassName() {
      return this.className != null;
    }

    public void setClassNameIsSet(boolean value) {
      if (!value) {
        this.className = null;
      }
    }

    public void setFieldValue(int fieldID, Object value) {
      switch (fieldID) {
      case CLASSNAME:
        if (value == null) {
          unsetClassName();
        } else {
          setClassName((String)value);
        }
        break;

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    public Object getFieldValue(int fieldID) {
      switch (fieldID) {
      case CLASSNAME:
        return getClassName();

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    // Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise
    public boolean isSet(int fieldID) {
      switch (fieldID) {
      case CLASSNAME:
        return isSetClassName();
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof getClass_args)
        return this.equals((getClass_args)that);
      return false;
    }

    public boolean equals(getClass_args that) {
      if (that == null)
        return false;

      boolean this_present_className = true && this.isSetClassName();
      boolean that_present_className = true && that.isSetClassName();
      if (this_present_className || that_present_className) {
        if (!(this_present_className && that_present_className))
          return false;
        if (!this.className.equals(that.className))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      return 0;
    }

    public int compareTo(getClass_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      getClass_args typedOther = (getClass_args)other;

      lastComparison = Boolean.valueOf(isSetClassName()).compareTo(isSetClassName());
      if (lastComparison != 0) {
        return lastComparison;
      }
      lastComparison = TBaseHelper.compareTo(className, typedOther.className);
      if (lastComparison != 0) {
        return lastComparison;
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id)
        {
          case CLASSNAME:
            if (field.type == TType.STRING) {
              this.className = iprot.readString();
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
            break;
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();


      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      validate();

      oprot.writeStructBegin(STRUCT_DESC);
      if (this.className != null) {
        oprot.writeFieldBegin(CLASS_NAME_FIELD_DESC);
        oprot.writeString(this.className);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("getClass_args(");
      boolean first = true;

      sb.append("className:");
      if (this.className == null) {
        sb.append("null");
      } else {
        sb.append(this.className);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
      // check that fields of type enum have valid values
    }

  }

  public static class getClass_result implements TBase, java.io.Serializable, Cloneable, Comparable<getClass_result>   {
    private static final TStruct STRUCT_DESC = new TStruct("getClass_result");
    private static final TField SUCCESS_FIELD_DESC = new TField("success", TType.STRING, (short)0);

    public byte[] success;
    public static final int SUCCESS = 0;

    // isset id assignments

    public static final Map<Integer, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new HashMap<Integer, FieldMetaData>() {{
      put(SUCCESS, new FieldMetaData("success", TFieldRequirementType.DEFAULT, 
          new FieldValueMetaData(TType.STRING)));
    }});

    static {
      FieldMetaData.addStructMetaDataMap(getClass_result.class, metaDataMap);
    }

    public static final Map<String, Integer> fieldNameMap = Collections.unmodifiableMap(new HashMap<String, Integer>() {{
      put("success", new Integer(SUCCESS));
    }});

    public getClass_result() {
    }

    public getClass_result(
      byte[] success)
    {
      this();
      this.success = success;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public getClass_result(getClass_result other) {
      if (other.isSetSuccess()) {
        this.success = new byte[other.success.length];
        System.arraycopy(other.success, 0, success, 0, other.success.length);
      }
    }

    public getClass_result deepCopy() {
      return new getClass_result(this);
    }

    @Deprecated
    public getClass_result clone() {
      return new getClass_result(this);
    }

    public byte[] getSuccess() {
      return this.success;
    }

    public getClass_result setSuccess(byte[] success) {
      this.success = success;
      return this;
    }

    public void unsetSuccess() {
      this.success = null;
    }

    // Returns true if field success is set (has been asigned a value) and false otherwise
    public boolean isSetSuccess() {
      return this.success != null;
    }

    public void setSuccessIsSet(boolean value) {
      if (!value) {
        this.success = null;
      }
    }

    public void setFieldValue(int fieldID, Object value) {
      switch (fieldID) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((byte[])value);
        }
        break;

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    public Object getFieldValue(int fieldID) {
      switch (fieldID) {
      case SUCCESS:
        return getSuccess();

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    // Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise
    public boolean isSet(int fieldID) {
      switch (fieldID) {
      case SUCCESS:
        return isSetSuccess();
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof getClass_result)
        return this.equals((getClass_result)that);
      return false;
    }

    public boolean equals(getClass_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true && this.isSetSuccess();
      boolean that_present_success = true && that.isSetSuccess();
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (!java.util.Arrays.equals(this.success, that.success))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      return 0;
    }

    public int compareTo(getClass_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      getClass_result typedOther = (getClass_result)other;

      lastComparison = Boolean.valueOf(isSetSuccess()).compareTo(isSetSuccess());
      if (lastComparison != 0) {
        return lastComparison;
      }
      lastComparison = TBaseHelper.compareTo(success, typedOther.success);
      if (lastComparison != 0) {
        return lastComparison;
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id)
        {
          case SUCCESS:
            if (field.type == TType.STRING) {
              this.success = iprot.readBinary();
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
            break;
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();


      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      oprot.writeStructBegin(STRUCT_DESC);

      if (this.isSetSuccess()) {
        oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
        oprot.writeBinary(this.success);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("getClass_result(");
      boolean first = true;

      sb.append("success:");
      if (this.success == null) {
        sb.append("null");
      } else {
          int __success_size = Math.min(this.success.length, 128);
          for (int i = 0; i < __success_size; i++) {
            if (i != 0) sb.append(" ");
            sb.append(Integer.toHexString(this.success[i]).length() > 1 ? Integer.toHexString(this.success[i]).substring(Integer.toHexString(this.success[i]).length() - 2).toUpperCase() : "0" + Integer.toHexString(this.success[i]).toUpperCase());
          }
          if (this.success.length > 128) sb.append(" ...");
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
      // check that fields of type enum have valid values
    }

  }

  public static class classUpdate_args implements TBase, java.io.Serializable, Cloneable, Comparable<classUpdate_args>   {
    private static final TStruct STRUCT_DESC = new TStruct("classUpdate_args");
    private static final TField CLASS_NAME_FIELD_DESC = new TField("className", TType.STRING, (short)1);

    public String className;
    public static final int CLASSNAME = 1;

    // isset id assignments

    public static final Map<Integer, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new HashMap<Integer, FieldMetaData>() {{
      put(CLASSNAME, new FieldMetaData("className", TFieldRequirementType.DEFAULT, 
          new FieldValueMetaData(TType.STRING)));
    }});

    static {
      FieldMetaData.addStructMetaDataMap(classUpdate_args.class, metaDataMap);
    }

    public static final Map<String, Integer> fieldNameMap = Collections.unmodifiableMap(new HashMap<String, Integer>() {{
      put("className", new Integer(CLASSNAME));
    }});

    public classUpdate_args() {
    }

    public classUpdate_args(
      String className)
    {
      this();
      this.className = className;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public classUpdate_args(classUpdate_args other) {
      if (other.isSetClassName()) {
        this.className = other.className;
      }
    }

    public classUpdate_args deepCopy() {
      return new classUpdate_args(this);
    }

    @Deprecated
    public classUpdate_args clone() {
      return new classUpdate_args(this);
    }

    public String getClassName() {
      return this.className;
    }

    public classUpdate_args setClassName(String className) {
      this.className = className;
      return this;
    }

    public void unsetClassName() {
      this.className = null;
    }

    // Returns true if field className is set (has been asigned a value) and false otherwise
    public boolean isSetClassName() {
      return this.className != null;
    }

    public void setClassNameIsSet(boolean value) {
      if (!value) {
        this.className = null;
      }
    }

    public void setFieldValue(int fieldID, Object value) {
      switch (fieldID) {
      case CLASSNAME:
        if (value == null) {
          unsetClassName();
        } else {
          setClassName((String)value);
        }
        break;

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    public Object getFieldValue(int fieldID) {
      switch (fieldID) {
      case CLASSNAME:
        return getClassName();

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    // Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise
    public boolean isSet(int fieldID) {
      switch (fieldID) {
      case CLASSNAME:
        return isSetClassName();
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof classUpdate_args)
        return this.equals((classUpdate_args)that);
      return false;
    }

    public boolean equals(classUpdate_args that) {
      if (that == null)
        return false;

      boolean this_present_className = true && this.isSetClassName();
      boolean that_present_className = true && that.isSetClassName();
      if (this_present_className || that_present_className) {
        if (!(this_present_className && that_present_className))
          return false;
        if (!this.className.equals(that.className))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      return 0;
    }

    public int compareTo(classUpdate_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      classUpdate_args typedOther = (classUpdate_args)other;

      lastComparison = Boolean.valueOf(isSetClassName()).compareTo(isSetClassName());
      if (lastComparison != 0) {
        return lastComparison;
      }
      lastComparison = TBaseHelper.compareTo(className, typedOther.className);
      if (lastComparison != 0) {
        return lastComparison;
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id)
        {
          case CLASSNAME:
            if (field.type == TType.STRING) {
              this.className = iprot.readString();
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
            break;
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();


      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      validate();

      oprot.writeStructBegin(STRUCT_DESC);
      if (this.className != null) {
        oprot.writeFieldBegin(CLASS_NAME_FIELD_DESC);
        oprot.writeString(this.className);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("classUpdate_args(");
      boolean first = true;

      sb.append("className:");
      if (this.className == null) {
        sb.append("null");
      } else {
        sb.append(this.className);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
      // check that fields of type enum have valid values
    }

  }

  public static class getResource_args implements TBase, java.io.Serializable, Cloneable, Comparable<getResource_args>   {
    private static final TStruct STRUCT_DESC = new TStruct("getResource_args");
    private static final TField RESOURCE_NAME_FIELD_DESC = new TField("resourceName", TType.STRING, (short)1);

    public String resourceName;
    public static final int RESOURCENAME = 1;

    // isset id assignments

    public static final Map<Integer, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new HashMap<Integer, FieldMetaData>() {{
      put(RESOURCENAME, new FieldMetaData("resourceName", TFieldRequirementType.DEFAULT, 
          new FieldValueMetaData(TType.STRING)));
    }});

    static {
      FieldMetaData.addStructMetaDataMap(getResource_args.class, metaDataMap);
    }

    public static final Map<String, Integer> fieldNameMap = Collections.unmodifiableMap(new HashMap<String, Integer>() {{
      put("resourceName", new Integer(RESOURCENAME));
    }});

    public getResource_args() {
    }

    public getResource_args(
      String resourceName)
    {
      this();
      this.resourceName = resourceName;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public getResource_args(getResource_args other) {
      if (other.isSetResourceName()) {
        this.resourceName = other.resourceName;
      }
    }

    public getResource_args deepCopy() {
      return new getResource_args(this);
    }

    @Deprecated
    public getResource_args clone() {
      return new getResource_args(this);
    }

    public String getResourceName() {
      return this.resourceName;
    }

    public getResource_args setResourceName(String resourceName) {
      this.resourceName = resourceName;
      return this;
    }

    public void unsetResourceName() {
      this.resourceName = null;
    }

    // Returns true if field resourceName is set (has been asigned a value) and false otherwise
    public boolean isSetResourceName() {
      return this.resourceName != null;
    }

    public void setResourceNameIsSet(boolean value) {
      if (!value) {
        this.resourceName = null;
      }
    }

    public void setFieldValue(int fieldID, Object value) {
      switch (fieldID) {
      case RESOURCENAME:
        if (value == null) {
          unsetResourceName();
        } else {
          setResourceName((String)value);
        }
        break;

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    public Object getFieldValue(int fieldID) {
      switch (fieldID) {
      case RESOURCENAME:
        return getResourceName();

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    // Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise
    public boolean isSet(int fieldID) {
      switch (fieldID) {
      case RESOURCENAME:
        return isSetResourceName();
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof getResource_args)
        return this.equals((getResource_args)that);
      return false;
    }

    public boolean equals(getResource_args that) {
      if (that == null)
        return false;

      boolean this_present_resourceName = true && this.isSetResourceName();
      boolean that_present_resourceName = true && that.isSetResourceName();
      if (this_present_resourceName || that_present_resourceName) {
        if (!(this_present_resourceName && that_present_resourceName))
          return false;
        if (!this.resourceName.equals(that.resourceName))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      return 0;
    }

    public int compareTo(getResource_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      getResource_args typedOther = (getResource_args)other;

      lastComparison = Boolean.valueOf(isSetResourceName()).compareTo(isSetResourceName());
      if (lastComparison != 0) {
        return lastComparison;
      }
      lastComparison = TBaseHelper.compareTo(resourceName, typedOther.resourceName);
      if (lastComparison != 0) {
        return lastComparison;
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id)
        {
          case RESOURCENAME:
            if (field.type == TType.STRING) {
              this.resourceName = iprot.readString();
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
            break;
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();


      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      validate();

      oprot.writeStructBegin(STRUCT_DESC);
      if (this.resourceName != null) {
        oprot.writeFieldBegin(RESOURCE_NAME_FIELD_DESC);
        oprot.writeString(this.resourceName);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("getResource_args(");
      boolean first = true;

      sb.append("resourceName:");
      if (this.resourceName == null) {
        sb.append("null");
      } else {
        sb.append(this.resourceName);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
      // check that fields of type enum have valid values
    }

  }

  public static class getResource_result implements TBase, java.io.Serializable, Cloneable, Comparable<getResource_result>   {
    private static final TStruct STRUCT_DESC = new TStruct("getResource_result");
    private static final TField SUCCESS_FIELD_DESC = new TField("success", TType.STRING, (short)0);

    public byte[] success;
    public static final int SUCCESS = 0;

    // isset id assignments

    public static final Map<Integer, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new HashMap<Integer, FieldMetaData>() {{
      put(SUCCESS, new FieldMetaData("success", TFieldRequirementType.DEFAULT, 
          new FieldValueMetaData(TType.STRING)));
    }});

    static {
      FieldMetaData.addStructMetaDataMap(getResource_result.class, metaDataMap);
    }

    public static final Map<String, Integer> fieldNameMap = Collections.unmodifiableMap(new HashMap<String, Integer>() {{
      put("success", new Integer(SUCCESS));
    }});

    public getResource_result() {
    }

    public getResource_result(
      byte[] success)
    {
      this();
      this.success = success;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public getResource_result(getResource_result other) {
      if (other.isSetSuccess()) {
        this.success = new byte[other.success.length];
        System.arraycopy(other.success, 0, success, 0, other.success.length);
      }
    }

    public getResource_result deepCopy() {
      return new getResource_result(this);
    }

    @Deprecated
    public getResource_result clone() {
      return new getResource_result(this);
    }

    public byte[] getSuccess() {
      return this.success;
    }

    public getResource_result setSuccess(byte[] success) {
      this.success = success;
      return this;
    }

    public void unsetSuccess() {
      this.success = null;
    }

    // Returns true if field success is set (has been asigned a value) and false otherwise
    public boolean isSetSuccess() {
      return this.success != null;
    }

    public void setSuccessIsSet(boolean value) {
      if (!value) {
        this.success = null;
      }
    }

    public void setFieldValue(int fieldID, Object value) {
      switch (fieldID) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((byte[])value);
        }
        break;

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    public Object getFieldValue(int fieldID) {
      switch (fieldID) {
      case SUCCESS:
        return getSuccess();

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    // Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise
    public boolean isSet(int fieldID) {
      switch (fieldID) {
      case SUCCESS:
        return isSetSuccess();
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof getResource_result)
        return this.equals((getResource_result)that);
      return false;
    }

    public boolean equals(getResource_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true && this.isSetSuccess();
      boolean that_present_success = true && that.isSetSuccess();
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (!java.util.Arrays.equals(this.success, that.success))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      return 0;
    }

    public int compareTo(getResource_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      getResource_result typedOther = (getResource_result)other;

      lastComparison = Boolean.valueOf(isSetSuccess()).compareTo(isSetSuccess());
      if (lastComparison != 0) {
        return lastComparison;
      }
      lastComparison = TBaseHelper.compareTo(success, typedOther.success);
      if (lastComparison != 0) {
        return lastComparison;
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id)
        {
          case SUCCESS:
            if (field.type == TType.STRING) {
              this.success = iprot.readBinary();
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
            break;
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();


      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      oprot.writeStructBegin(STRUCT_DESC);

      if (this.isSetSuccess()) {
        oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
        oprot.writeBinary(this.success);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("getResource_result(");
      boolean first = true;

      sb.append("success:");
      if (this.success == null) {
        sb.append("null");
      } else {
          int __success_size = Math.min(this.success.length, 128);
          for (int i = 0; i < __success_size; i++) {
            if (i != 0) sb.append(" ");
            sb.append(Integer.toHexString(this.success[i]).length() > 1 ? Integer.toHexString(this.success[i]).substring(Integer.toHexString(this.success[i]).length() - 2).toUpperCase() : "0" + Integer.toHexString(this.success[i]).toUpperCase());
          }
          if (this.success.length > 128) sb.append(" ...");
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
      // check that fields of type enum have valid values
    }

  }

  public static class resourceUpdate_args implements TBase, java.io.Serializable, Cloneable, Comparable<resourceUpdate_args>   {
    private static final TStruct STRUCT_DESC = new TStruct("resourceUpdate_args");
    private static final TField RESOURCE_NAME_FIELD_DESC = new TField("resourceName", TType.STRING, (short)1);

    public String resourceName;
    public static final int RESOURCENAME = 1;

    // isset id assignments

    public static final Map<Integer, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new HashMap<Integer, FieldMetaData>() {{
      put(RESOURCENAME, new FieldMetaData("resourceName", TFieldRequirementType.DEFAULT, 
          new FieldValueMetaData(TType.STRING)));
    }});

    static {
      FieldMetaData.addStructMetaDataMap(resourceUpdate_args.class, metaDataMap);
    }

    public static final Map<String, Integer> fieldNameMap = Collections.unmodifiableMap(new HashMap<String, Integer>() {{
      put("resourceName", new Integer(RESOURCENAME));
    }});

    public resourceUpdate_args() {
    }

    public resourceUpdate_args(
      String resourceName)
    {
      this();
      this.resourceName = resourceName;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public resourceUpdate_args(resourceUpdate_args other) {
      if (other.isSetResourceName()) {
        this.resourceName = other.resourceName;
      }
    }

    public resourceUpdate_args deepCopy() {
      return new resourceUpdate_args(this);
    }

    @Deprecated
    public resourceUpdate_args clone() {
      return new resourceUpdate_args(this);
    }

    public String getResourceName() {
      return this.resourceName;
    }

    public resourceUpdate_args setResourceName(String resourceName) {
      this.resourceName = resourceName;
      return this;
    }

    public void unsetResourceName() {
      this.resourceName = null;
    }

    // Returns true if field resourceName is set (has been asigned a value) and false otherwise
    public boolean isSetResourceName() {
      return this.resourceName != null;
    }

    public void setResourceNameIsSet(boolean value) {
      if (!value) {
        this.resourceName = null;
      }
    }

    public void setFieldValue(int fieldID, Object value) {
      switch (fieldID) {
      case RESOURCENAME:
        if (value == null) {
          unsetResourceName();
        } else {
          setResourceName((String)value);
        }
        break;

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    public Object getFieldValue(int fieldID) {
      switch (fieldID) {
      case RESOURCENAME:
        return getResourceName();

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    // Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise
    public boolean isSet(int fieldID) {
      switch (fieldID) {
      case RESOURCENAME:
        return isSetResourceName();
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof resourceUpdate_args)
        return this.equals((resourceUpdate_args)that);
      return false;
    }

    public boolean equals(resourceUpdate_args that) {
      if (that == null)
        return false;

      boolean this_present_resourceName = true && this.isSetResourceName();
      boolean that_present_resourceName = true && that.isSetResourceName();
      if (this_present_resourceName || that_present_resourceName) {
        if (!(this_present_resourceName && that_present_resourceName))
          return false;
        if (!this.resourceName.equals(that.resourceName))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      return 0;
    }

    public int compareTo(resourceUpdate_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      resourceUpdate_args typedOther = (resourceUpdate_args)other;

      lastComparison = Boolean.valueOf(isSetResourceName()).compareTo(isSetResourceName());
      if (lastComparison != 0) {
        return lastComparison;
      }
      lastComparison = TBaseHelper.compareTo(resourceName, typedOther.resourceName);
      if (lastComparison != 0) {
        return lastComparison;
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id)
        {
          case RESOURCENAME:
            if (field.type == TType.STRING) {
              this.resourceName = iprot.readString();
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
            break;
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();


      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      validate();

      oprot.writeStructBegin(STRUCT_DESC);
      if (this.resourceName != null) {
        oprot.writeFieldBegin(RESOURCE_NAME_FIELD_DESC);
        oprot.writeString(this.resourceName);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("resourceUpdate_args(");
      boolean first = true;

      sb.append("resourceName:");
      if (this.resourceName == null) {
        sb.append("null");
      } else {
        sb.append(this.resourceName);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
      // check that fields of type enum have valid values
    }

  }

  public static class getProperties_args implements TBase, java.io.Serializable, Cloneable, Comparable<getProperties_args>   {
    private static final TStruct STRUCT_DESC = new TStruct("getProperties_args");

    public static final Map<Integer, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new HashMap<Integer, FieldMetaData>() {{
    }});

    static {
      FieldMetaData.addStructMetaDataMap(getProperties_args.class, metaDataMap);
    }

    public static final Map<String, Integer> fieldNameMap = Collections.unmodifiableMap(new HashMap<String, Integer>() {{
    }});

    public getProperties_args() {
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public getProperties_args(getProperties_args other) {
    }

    public getProperties_args deepCopy() {
      return new getProperties_args(this);
    }

    @Deprecated
    public getProperties_args clone() {
      return new getProperties_args(this);
    }

    public void setFieldValue(int fieldID, Object value) {
      switch (fieldID) {
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    public Object getFieldValue(int fieldID) {
      switch (fieldID) {
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    // Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise
    public boolean isSet(int fieldID) {
      switch (fieldID) {
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof getProperties_args)
        return this.equals((getProperties_args)that);
      return false;
    }

    public boolean equals(getProperties_args that) {
      if (that == null)
        return false;

      return true;
    }

    @Override
    public int hashCode() {
      return 0;
    }

    public int compareTo(getProperties_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      getProperties_args typedOther = (getProperties_args)other;

      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id)
        {
          default:
            TProtocolUtil.skip(iprot, field.type);
            break;
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();


      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      validate();

      oprot.writeStructBegin(STRUCT_DESC);
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("getProperties_args(");
      boolean first = true;

      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
      // check that fields of type enum have valid values
    }

  }

  public static class getProperties_result implements TBase, java.io.Serializable, Cloneable, Comparable<getProperties_result>   {
    private static final TStruct STRUCT_DESC = new TStruct("getProperties_result");
    private static final TField SUCCESS_FIELD_DESC = new TField("success", TType.LIST, (short)0);

    public List<PropertyEvent> success;
    public static final int SUCCESS = 0;

    // isset id assignments

    public static final Map<Integer, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new HashMap<Integer, FieldMetaData>() {{
      put(SUCCESS, new FieldMetaData("success", TFieldRequirementType.DEFAULT, 
          new ListMetaData(TType.LIST, 
              new StructMetaData(TType.STRUCT, PropertyEvent.class))));
    }});

    static {
      FieldMetaData.addStructMetaDataMap(getProperties_result.class, metaDataMap);
    }

    public static final Map<String, Integer> fieldNameMap = Collections.unmodifiableMap(new HashMap<String, Integer>() {{
      put("success", new Integer(SUCCESS));
    }});

    public getProperties_result() {
    }

    public getProperties_result(
      List<PropertyEvent> success)
    {
      this();
      this.success = success;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public getProperties_result(getProperties_result other) {
      if (other.isSetSuccess()) {
        List<PropertyEvent> __this__success = new ArrayList<PropertyEvent>();
        for (PropertyEvent other_element : other.success) {
          __this__success.add(new PropertyEvent(other_element));
        }
        this.success = __this__success;
      }
    }

    public getProperties_result deepCopy() {
      return new getProperties_result(this);
    }

    @Deprecated
    public getProperties_result clone() {
      return new getProperties_result(this);
    }

    public int getSuccessSize() {
      return (this.success == null) ? 0 : this.success.size();
    }

    public java.util.Iterator<PropertyEvent> getSuccessIterator() {
      return (this.success == null) ? null : this.success.iterator();
    }

    public void addToSuccess(PropertyEvent elem) {
      if (this.success == null) {
        this.success = new ArrayList<PropertyEvent>();
      }
      this.success.add(elem);
    }

    public List<PropertyEvent> getSuccess() {
      return this.success;
    }

    public getProperties_result setSuccess(List<PropertyEvent> success) {
      this.success = success;
      return this;
    }

    public void unsetSuccess() {
      this.success = null;
    }

    // Returns true if field success is set (has been asigned a value) and false otherwise
    public boolean isSetSuccess() {
      return this.success != null;
    }

    public void setSuccessIsSet(boolean value) {
      if (!value) {
        this.success = null;
      }
    }

    public void setFieldValue(int fieldID, Object value) {
      switch (fieldID) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((List<PropertyEvent>)value);
        }
        break;

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    public Object getFieldValue(int fieldID) {
      switch (fieldID) {
      case SUCCESS:
        return getSuccess();

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    // Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise
    public boolean isSet(int fieldID) {
      switch (fieldID) {
      case SUCCESS:
        return isSetSuccess();
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof getProperties_result)
        return this.equals((getProperties_result)that);
      return false;
    }

    public boolean equals(getProperties_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true && this.isSetSuccess();
      boolean that_present_success = true && that.isSetSuccess();
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (!this.success.equals(that.success))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      return 0;
    }

    public int compareTo(getProperties_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      getProperties_result typedOther = (getProperties_result)other;

      lastComparison = Boolean.valueOf(isSetSuccess()).compareTo(isSetSuccess());
      if (lastComparison != 0) {
        return lastComparison;
      }
      lastComparison = TBaseHelper.compareTo(success, typedOther.success);
      if (lastComparison != 0) {
        return lastComparison;
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id)
        {
          case SUCCESS:
            if (field.type == TType.LIST) {
              {
                TList _list21 = iprot.readListBegin();
                this.success = new ArrayList<PropertyEvent>(_list21.size);
                for (int _i22 = 0; _i22 < _list21.size; ++_i22)
                {
                  PropertyEvent _elem23;
                  _elem23 = new PropertyEvent();
                  _elem23.read(iprot);
                  this.success.add(_elem23);
                }
                iprot.readListEnd();
              }
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
            break;
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();


      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      oprot.writeStructBegin(STRUCT_DESC);

      if (this.isSetSuccess()) {
        oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
        {
          oprot.writeListBegin(new TList(TType.STRUCT, this.success.size()));
          for (PropertyEvent _iter24 : this.success)
          {
            _iter24.write(oprot);
          }
          oprot.writeListEnd();
        }
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("getProperties_result(");
      boolean first = true;

      sb.append("success:");
      if (this.success == null) {
        sb.append("null");
      } else {
        sb.append(this.success);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
      // check that fields of type enum have valid values
    }

  }

  public static class getProperty_args implements TBase, java.io.Serializable, Cloneable, Comparable<getProperty_args>   {
    private static final TStruct STRUCT_DESC = new TStruct("getProperty_args");
    private static final TField KEY_FIELD_DESC = new TField("key", TType.STRING, (short)1);

    public String key;
    public static final int KEY = 1;

    // isset id assignments

    public static final Map<Integer, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new HashMap<Integer, FieldMetaData>() {{
      put(KEY, new FieldMetaData("key", TFieldRequirementType.DEFAULT, 
          new FieldValueMetaData(TType.STRING)));
    }});

    static {
      FieldMetaData.addStructMetaDataMap(getProperty_args.class, metaDataMap);
    }

    public static final Map<String, Integer> fieldNameMap = Collections.unmodifiableMap(new HashMap<String, Integer>() {{
      put("key", new Integer(KEY));
    }});

    public getProperty_args() {
    }

    public getProperty_args(
      String key)
    {
      this();
      this.key = key;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public getProperty_args(getProperty_args other) {
      if (other.isSetKey()) {
        this.key = other.key;
      }
    }

    public getProperty_args deepCopy() {
      return new getProperty_args(this);
    }

    @Deprecated
    public getProperty_args clone() {
      return new getProperty_args(this);
    }

    public String getKey() {
      return this.key;
    }

    public getProperty_args setKey(String key) {
      this.key = key;
      return this;
    }

    public void unsetKey() {
      this.key = null;
    }

    // Returns true if field key is set (has been asigned a value) and false otherwise
    public boolean isSetKey() {
      return this.key != null;
    }

    public void setKeyIsSet(boolean value) {
      if (!value) {
        this.key = null;
      }
    }

    public void setFieldValue(int fieldID, Object value) {
      switch (fieldID) {
      case KEY:
        if (value == null) {
          unsetKey();
        } else {
          setKey((String)value);
        }
        break;

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    public Object getFieldValue(int fieldID) {
      switch (fieldID) {
      case KEY:
        return getKey();

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    // Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise
    public boolean isSet(int fieldID) {
      switch (fieldID) {
      case KEY:
        return isSetKey();
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof getProperty_args)
        return this.equals((getProperty_args)that);
      return false;
    }

    public boolean equals(getProperty_args that) {
      if (that == null)
        return false;

      boolean this_present_key = true && this.isSetKey();
      boolean that_present_key = true && that.isSetKey();
      if (this_present_key || that_present_key) {
        if (!(this_present_key && that_present_key))
          return false;
        if (!this.key.equals(that.key))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      return 0;
    }

    public int compareTo(getProperty_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      getProperty_args typedOther = (getProperty_args)other;

      lastComparison = Boolean.valueOf(isSetKey()).compareTo(isSetKey());
      if (lastComparison != 0) {
        return lastComparison;
      }
      lastComparison = TBaseHelper.compareTo(key, typedOther.key);
      if (lastComparison != 0) {
        return lastComparison;
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id)
        {
          case KEY:
            if (field.type == TType.STRING) {
              this.key = iprot.readString();
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
            break;
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();


      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      validate();

      oprot.writeStructBegin(STRUCT_DESC);
      if (this.key != null) {
        oprot.writeFieldBegin(KEY_FIELD_DESC);
        oprot.writeString(this.key);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("getProperty_args(");
      boolean first = true;

      sb.append("key:");
      if (this.key == null) {
        sb.append("null");
      } else {
        sb.append(this.key);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
      // check that fields of type enum have valid values
    }

  }

  public static class getProperty_result implements TBase, java.io.Serializable, Cloneable, Comparable<getProperty_result>   {
    private static final TStruct STRUCT_DESC = new TStruct("getProperty_result");
    private static final TField SUCCESS_FIELD_DESC = new TField("success", TType.STRING, (short)0);

    public String success;
    public static final int SUCCESS = 0;

    // isset id assignments

    public static final Map<Integer, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new HashMap<Integer, FieldMetaData>() {{
      put(SUCCESS, new FieldMetaData("success", TFieldRequirementType.DEFAULT, 
          new FieldValueMetaData(TType.STRING)));
    }});

    static {
      FieldMetaData.addStructMetaDataMap(getProperty_result.class, metaDataMap);
    }

    public static final Map<String, Integer> fieldNameMap = Collections.unmodifiableMap(new HashMap<String, Integer>() {{
      put("success", new Integer(SUCCESS));
    }});

    public getProperty_result() {
    }

    public getProperty_result(
      String success)
    {
      this();
      this.success = success;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public getProperty_result(getProperty_result other) {
      if (other.isSetSuccess()) {
        this.success = other.success;
      }
    }

    public getProperty_result deepCopy() {
      return new getProperty_result(this);
    }

    @Deprecated
    public getProperty_result clone() {
      return new getProperty_result(this);
    }

    public String getSuccess() {
      return this.success;
    }

    public getProperty_result setSuccess(String success) {
      this.success = success;
      return this;
    }

    public void unsetSuccess() {
      this.success = null;
    }

    // Returns true if field success is set (has been asigned a value) and false otherwise
    public boolean isSetSuccess() {
      return this.success != null;
    }

    public void setSuccessIsSet(boolean value) {
      if (!value) {
        this.success = null;
      }
    }

    public void setFieldValue(int fieldID, Object value) {
      switch (fieldID) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((String)value);
        }
        break;

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    public Object getFieldValue(int fieldID) {
      switch (fieldID) {
      case SUCCESS:
        return getSuccess();

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    // Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise
    public boolean isSet(int fieldID) {
      switch (fieldID) {
      case SUCCESS:
        return isSetSuccess();
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof getProperty_result)
        return this.equals((getProperty_result)that);
      return false;
    }

    public boolean equals(getProperty_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true && this.isSetSuccess();
      boolean that_present_success = true && that.isSetSuccess();
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (!this.success.equals(that.success))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      return 0;
    }

    public int compareTo(getProperty_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      getProperty_result typedOther = (getProperty_result)other;

      lastComparison = Boolean.valueOf(isSetSuccess()).compareTo(isSetSuccess());
      if (lastComparison != 0) {
        return lastComparison;
      }
      lastComparison = TBaseHelper.compareTo(success, typedOther.success);
      if (lastComparison != 0) {
        return lastComparison;
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id)
        {
          case SUCCESS:
            if (field.type == TType.STRING) {
              this.success = iprot.readString();
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
            break;
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();


      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      oprot.writeStructBegin(STRUCT_DESC);

      if (this.isSetSuccess()) {
        oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
        oprot.writeString(this.success);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("getProperty_result(");
      boolean first = true;

      sb.append("success:");
      if (this.success == null) {
        sb.append("null");
      } else {
        sb.append(this.success);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
      // check that fields of type enum have valid values
    }

  }

  public static class setProperty_args implements TBase, java.io.Serializable, Cloneable, Comparable<setProperty_args>   {
    private static final TStruct STRUCT_DESC = new TStruct("setProperty_args");
    private static final TField KEY_FIELD_DESC = new TField("key", TType.STRING, (short)1);
    private static final TField VALUE_FIELD_DESC = new TField("value", TType.STRING, (short)2);

    public String key;
    public String value;
    public static final int KEY = 1;
    public static final int VALUE = 2;

    // isset id assignments

    public static final Map<Integer, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new HashMap<Integer, FieldMetaData>() {{
      put(KEY, new FieldMetaData("key", TFieldRequirementType.DEFAULT, 
          new FieldValueMetaData(TType.STRING)));
      put(VALUE, new FieldMetaData("value", TFieldRequirementType.DEFAULT, 
          new FieldValueMetaData(TType.STRING)));
    }});

    static {
      FieldMetaData.addStructMetaDataMap(setProperty_args.class, metaDataMap);
    }

    public static final Map<String, Integer> fieldNameMap = Collections.unmodifiableMap(new HashMap<String, Integer>() {{
      put("key", new Integer(KEY));
      put("value", new Integer(VALUE));
    }});

    public setProperty_args() {
    }

    public setProperty_args(
      String key,
      String value)
    {
      this();
      this.key = key;
      this.value = value;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public setProperty_args(setProperty_args other) {
      if (other.isSetKey()) {
        this.key = other.key;
      }
      if (other.isSetValue()) {
        this.value = other.value;
      }
    }

    public setProperty_args deepCopy() {
      return new setProperty_args(this);
    }

    @Deprecated
    public setProperty_args clone() {
      return new setProperty_args(this);
    }

    public String getKey() {
      return this.key;
    }

    public setProperty_args setKey(String key) {
      this.key = key;
      return this;
    }

    public void unsetKey() {
      this.key = null;
    }

    // Returns true if field key is set (has been asigned a value) and false otherwise
    public boolean isSetKey() {
      return this.key != null;
    }

    public void setKeyIsSet(boolean value) {
      if (!value) {
        this.key = null;
      }
    }

    public String getValue() {
      return this.value;
    }

    public setProperty_args setValue(String value) {
      this.value = value;
      return this;
    }

    public void unsetValue() {
      this.value = null;
    }

    // Returns true if field value is set (has been asigned a value) and false otherwise
    public boolean isSetValue() {
      return this.value != null;
    }

    public void setValueIsSet(boolean value) {
      if (!value) {
        this.value = null;
      }
    }

    public void setFieldValue(int fieldID, Object value) {
      switch (fieldID) {
      case KEY:
        if (value == null) {
          unsetKey();
        } else {
          setKey((String)value);
        }
        break;

      case VALUE:
        if (value == null) {
          unsetValue();
        } else {
          setValue((String)value);
        }
        break;

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    public Object getFieldValue(int fieldID) {
      switch (fieldID) {
      case KEY:
        return getKey();

      case VALUE:
        return getValue();

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    // Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise
    public boolean isSet(int fieldID) {
      switch (fieldID) {
      case KEY:
        return isSetKey();
      case VALUE:
        return isSetValue();
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof setProperty_args)
        return this.equals((setProperty_args)that);
      return false;
    }

    public boolean equals(setProperty_args that) {
      if (that == null)
        return false;

      boolean this_present_key = true && this.isSetKey();
      boolean that_present_key = true && that.isSetKey();
      if (this_present_key || that_present_key) {
        if (!(this_present_key && that_present_key))
          return false;
        if (!this.key.equals(that.key))
          return false;
      }

      boolean this_present_value = true && this.isSetValue();
      boolean that_present_value = true && that.isSetValue();
      if (this_present_value || that_present_value) {
        if (!(this_present_value && that_present_value))
          return false;
        if (!this.value.equals(that.value))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      return 0;
    }

    public int compareTo(setProperty_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      setProperty_args typedOther = (setProperty_args)other;

      lastComparison = Boolean.valueOf(isSetKey()).compareTo(isSetKey());
      if (lastComparison != 0) {
        return lastComparison;
      }
      lastComparison = TBaseHelper.compareTo(key, typedOther.key);
      if (lastComparison != 0) {
        return lastComparison;
      }
      lastComparison = Boolean.valueOf(isSetValue()).compareTo(isSetValue());
      if (lastComparison != 0) {
        return lastComparison;
      }
      lastComparison = TBaseHelper.compareTo(value, typedOther.value);
      if (lastComparison != 0) {
        return lastComparison;
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id)
        {
          case KEY:
            if (field.type == TType.STRING) {
              this.key = iprot.readString();
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          case VALUE:
            if (field.type == TType.STRING) {
              this.value = iprot.readString();
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
            break;
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();


      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      validate();

      oprot.writeStructBegin(STRUCT_DESC);
      if (this.key != null) {
        oprot.writeFieldBegin(KEY_FIELD_DESC);
        oprot.writeString(this.key);
        oprot.writeFieldEnd();
      }
      if (this.value != null) {
        oprot.writeFieldBegin(VALUE_FIELD_DESC);
        oprot.writeString(this.value);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("setProperty_args(");
      boolean first = true;

      sb.append("key:");
      if (this.key == null) {
        sb.append("null");
      } else {
        sb.append(this.key);
      }
      first = false;
      if (!first) sb.append(", ");
      sb.append("value:");
      if (this.value == null) {
        sb.append("null");
      } else {
        sb.append(this.value);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
      // check that fields of type enum have valid values
    }

  }

  public static class setProperty_result implements TBase, java.io.Serializable, Cloneable, Comparable<setProperty_result>   {
    private static final TStruct STRUCT_DESC = new TStruct("setProperty_result");

    public static final Map<Integer, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new HashMap<Integer, FieldMetaData>() {{
    }});

    static {
      FieldMetaData.addStructMetaDataMap(setProperty_result.class, metaDataMap);
    }

    public static final Map<String, Integer> fieldNameMap = Collections.unmodifiableMap(new HashMap<String, Integer>() {{
    }});

    public setProperty_result() {
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public setProperty_result(setProperty_result other) {
    }

    public setProperty_result deepCopy() {
      return new setProperty_result(this);
    }

    @Deprecated
    public setProperty_result clone() {
      return new setProperty_result(this);
    }

    public void setFieldValue(int fieldID, Object value) {
      switch (fieldID) {
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    public Object getFieldValue(int fieldID) {
      switch (fieldID) {
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    // Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise
    public boolean isSet(int fieldID) {
      switch (fieldID) {
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof setProperty_result)
        return this.equals((setProperty_result)that);
      return false;
    }

    public boolean equals(setProperty_result that) {
      if (that == null)
        return false;

      return true;
    }

    @Override
    public int hashCode() {
      return 0;
    }

    public int compareTo(setProperty_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      setProperty_result typedOther = (setProperty_result)other;

      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id)
        {
          default:
            TProtocolUtil.skip(iprot, field.type);
            break;
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();


      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      oprot.writeStructBegin(STRUCT_DESC);

      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("setProperty_result(");
      boolean first = true;

      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
      // check that fields of type enum have valid values
    }

  }

  public static class getContest_args implements TBase, java.io.Serializable, Cloneable, Comparable<getContest_args>   {
    private static final TStruct STRUCT_DESC = new TStruct("getContest_args");
    private static final TField CONTEST_FIELD_DESC = new TField("contest", TType.STRUCT, (short)1);

    public ContestId contest;
    public static final int CONTEST = 1;

    // isset id assignments

    public static final Map<Integer, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new HashMap<Integer, FieldMetaData>() {{
      put(CONTEST, new FieldMetaData("contest", TFieldRequirementType.DEFAULT, 
          new StructMetaData(TType.STRUCT, ContestId.class)));
    }});

    static {
      FieldMetaData.addStructMetaDataMap(getContest_args.class, metaDataMap);
    }

    public static final Map<String, Integer> fieldNameMap = Collections.unmodifiableMap(new HashMap<String, Integer>() {{
      put("contest", new Integer(CONTEST));
    }});

    public getContest_args() {
    }

    public getContest_args(
      ContestId contest)
    {
      this();
      this.contest = contest;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public getContest_args(getContest_args other) {
      if (other.isSetContest()) {
        this.contest = new ContestId(other.contest);
      }
    }

    public getContest_args deepCopy() {
      return new getContest_args(this);
    }

    @Deprecated
    public getContest_args clone() {
      return new getContest_args(this);
    }

    public ContestId getContest() {
      return this.contest;
    }

    public getContest_args setContest(ContestId contest) {
      this.contest = contest;
      return this;
    }

    public void unsetContest() {
      this.contest = null;
    }

    // Returns true if field contest is set (has been asigned a value) and false otherwise
    public boolean isSetContest() {
      return this.contest != null;
    }

    public void setContestIsSet(boolean value) {
      if (!value) {
        this.contest = null;
      }
    }

    public void setFieldValue(int fieldID, Object value) {
      switch (fieldID) {
      case CONTEST:
        if (value == null) {
          unsetContest();
        } else {
          setContest((ContestId)value);
        }
        break;

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    public Object getFieldValue(int fieldID) {
      switch (fieldID) {
      case CONTEST:
        return getContest();

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    // Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise
    public boolean isSet(int fieldID) {
      switch (fieldID) {
      case CONTEST:
        return isSetContest();
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof getContest_args)
        return this.equals((getContest_args)that);
      return false;
    }

    public boolean equals(getContest_args that) {
      if (that == null)
        return false;

      boolean this_present_contest = true && this.isSetContest();
      boolean that_present_contest = true && that.isSetContest();
      if (this_present_contest || that_present_contest) {
        if (!(this_present_contest && that_present_contest))
          return false;
        if (!this.contest.equals(that.contest))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      return 0;
    }

    public int compareTo(getContest_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      getContest_args typedOther = (getContest_args)other;

      lastComparison = Boolean.valueOf(isSetContest()).compareTo(isSetContest());
      if (lastComparison != 0) {
        return lastComparison;
      }
      lastComparison = TBaseHelper.compareTo(contest, typedOther.contest);
      if (lastComparison != 0) {
        return lastComparison;
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id)
        {
          case CONTEST:
            if (field.type == TType.STRUCT) {
              this.contest = new ContestId();
              this.contest.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
            break;
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();


      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      validate();

      oprot.writeStructBegin(STRUCT_DESC);
      if (this.contest != null) {
        oprot.writeFieldBegin(CONTEST_FIELD_DESC);
        this.contest.write(oprot);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("getContest_args(");
      boolean first = true;

      sb.append("contest:");
      if (this.contest == null) {
        sb.append("null");
      } else {
        sb.append(this.contest);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
      // check that fields of type enum have valid values
    }

  }

  public static class getContest_result implements TBase, java.io.Serializable, Cloneable   {
    private static final TStruct STRUCT_DESC = new TStruct("getContest_result");
    private static final TField SUCCESS_FIELD_DESC = new TField("success", TType.STRUCT, (short)0);

    public ContestDump success;
    public static final int SUCCESS = 0;

    // isset id assignments

    public static final Map<Integer, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new HashMap<Integer, FieldMetaData>() {{
      put(SUCCESS, new FieldMetaData("success", TFieldRequirementType.DEFAULT, 
          new StructMetaData(TType.STRUCT, ContestDump.class)));
    }});

    static {
      FieldMetaData.addStructMetaDataMap(getContest_result.class, metaDataMap);
    }

    public static final Map<String, Integer> fieldNameMap = Collections.unmodifiableMap(new HashMap<String, Integer>() {{
      put("success", new Integer(SUCCESS));
    }});

    public getContest_result() {
    }

    public getContest_result(
      ContestDump success)
    {
      this();
      this.success = success;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public getContest_result(getContest_result other) {
      if (other.isSetSuccess()) {
        this.success = new ContestDump(other.success);
      }
    }

    public getContest_result deepCopy() {
      return new getContest_result(this);
    }

    @Deprecated
    public getContest_result clone() {
      return new getContest_result(this);
    }

    public ContestDump getSuccess() {
      return this.success;
    }

    public getContest_result setSuccess(ContestDump success) {
      this.success = success;
      return this;
    }

    public void unsetSuccess() {
      this.success = null;
    }

    // Returns true if field success is set (has been asigned a value) and false otherwise
    public boolean isSetSuccess() {
      return this.success != null;
    }

    public void setSuccessIsSet(boolean value) {
      if (!value) {
        this.success = null;
      }
    }

    public void setFieldValue(int fieldID, Object value) {
      switch (fieldID) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((ContestDump)value);
        }
        break;

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    public Object getFieldValue(int fieldID) {
      switch (fieldID) {
      case SUCCESS:
        return getSuccess();

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    // Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise
    public boolean isSet(int fieldID) {
      switch (fieldID) {
      case SUCCESS:
        return isSetSuccess();
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof getContest_result)
        return this.equals((getContest_result)that);
      return false;
    }

    public boolean equals(getContest_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true && this.isSetSuccess();
      boolean that_present_success = true && that.isSetSuccess();
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (!this.success.equals(that.success))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id)
        {
          case SUCCESS:
            if (field.type == TType.STRUCT) {
              this.success = new ContestDump();
              this.success.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
            break;
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();


      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      oprot.writeStructBegin(STRUCT_DESC);

      if (this.isSetSuccess()) {
        oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
        this.success.write(oprot);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("getContest_result(");
      boolean first = true;

      sb.append("success:");
      if (this.success == null) {
        sb.append("null");
      } else {
        sb.append(this.success);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
      // check that fields of type enum have valid values
    }

  }

  public static class addContest_args implements TBase, java.io.Serializable, Cloneable, Comparable<addContest_args>   {
    private static final TStruct STRUCT_DESC = new TStruct("addContest_args");
    private static final TField CONTEST_FIELD_DESC = new TField("contest", TType.STRUCT, (short)1);

    public ContestId contest;
    public static final int CONTEST = 1;

    // isset id assignments

    public static final Map<Integer, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new HashMap<Integer, FieldMetaData>() {{
      put(CONTEST, new FieldMetaData("contest", TFieldRequirementType.DEFAULT, 
          new StructMetaData(TType.STRUCT, ContestId.class)));
    }});

    static {
      FieldMetaData.addStructMetaDataMap(addContest_args.class, metaDataMap);
    }

    public static final Map<String, Integer> fieldNameMap = Collections.unmodifiableMap(new HashMap<String, Integer>() {{
      put("contest", new Integer(CONTEST));
    }});

    public addContest_args() {
    }

    public addContest_args(
      ContestId contest)
    {
      this();
      this.contest = contest;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public addContest_args(addContest_args other) {
      if (other.isSetContest()) {
        this.contest = new ContestId(other.contest);
      }
    }

    public addContest_args deepCopy() {
      return new addContest_args(this);
    }

    @Deprecated
    public addContest_args clone() {
      return new addContest_args(this);
    }

    public ContestId getContest() {
      return this.contest;
    }

    public addContest_args setContest(ContestId contest) {
      this.contest = contest;
      return this;
    }

    public void unsetContest() {
      this.contest = null;
    }

    // Returns true if field contest is set (has been asigned a value) and false otherwise
    public boolean isSetContest() {
      return this.contest != null;
    }

    public void setContestIsSet(boolean value) {
      if (!value) {
        this.contest = null;
      }
    }

    public void setFieldValue(int fieldID, Object value) {
      switch (fieldID) {
      case CONTEST:
        if (value == null) {
          unsetContest();
        } else {
          setContest((ContestId)value);
        }
        break;

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    public Object getFieldValue(int fieldID) {
      switch (fieldID) {
      case CONTEST:
        return getContest();

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    // Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise
    public boolean isSet(int fieldID) {
      switch (fieldID) {
      case CONTEST:
        return isSetContest();
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof addContest_args)
        return this.equals((addContest_args)that);
      return false;
    }

    public boolean equals(addContest_args that) {
      if (that == null)
        return false;

      boolean this_present_contest = true && this.isSetContest();
      boolean that_present_contest = true && that.isSetContest();
      if (this_present_contest || that_present_contest) {
        if (!(this_present_contest && that_present_contest))
          return false;
        if (!this.contest.equals(that.contest))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      return 0;
    }

    public int compareTo(addContest_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      addContest_args typedOther = (addContest_args)other;

      lastComparison = Boolean.valueOf(isSetContest()).compareTo(isSetContest());
      if (lastComparison != 0) {
        return lastComparison;
      }
      lastComparison = TBaseHelper.compareTo(contest, typedOther.contest);
      if (lastComparison != 0) {
        return lastComparison;
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id)
        {
          case CONTEST:
            if (field.type == TType.STRUCT) {
              this.contest = new ContestId();
              this.contest.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
            break;
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();


      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      validate();

      oprot.writeStructBegin(STRUCT_DESC);
      if (this.contest != null) {
        oprot.writeFieldBegin(CONTEST_FIELD_DESC);
        this.contest.write(oprot);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("addContest_args(");
      boolean first = true;

      sb.append("contest:");
      if (this.contest == null) {
        sb.append("null");
      } else {
        sb.append(this.contest);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
      // check that fields of type enum have valid values
    }

  }

  public static class addContest_result implements TBase, java.io.Serializable, Cloneable, Comparable<addContest_result>   {
    private static final TStruct STRUCT_DESC = new TStruct("addContest_result");

    public static final Map<Integer, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new HashMap<Integer, FieldMetaData>() {{
    }});

    static {
      FieldMetaData.addStructMetaDataMap(addContest_result.class, metaDataMap);
    }

    public static final Map<String, Integer> fieldNameMap = Collections.unmodifiableMap(new HashMap<String, Integer>() {{
    }});

    public addContest_result() {
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public addContest_result(addContest_result other) {
    }

    public addContest_result deepCopy() {
      return new addContest_result(this);
    }

    @Deprecated
    public addContest_result clone() {
      return new addContest_result(this);
    }

    public void setFieldValue(int fieldID, Object value) {
      switch (fieldID) {
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    public Object getFieldValue(int fieldID) {
      switch (fieldID) {
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    // Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise
    public boolean isSet(int fieldID) {
      switch (fieldID) {
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof addContest_result)
        return this.equals((addContest_result)that);
      return false;
    }

    public boolean equals(addContest_result that) {
      if (that == null)
        return false;

      return true;
    }

    @Override
    public int hashCode() {
      return 0;
    }

    public int compareTo(addContest_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      addContest_result typedOther = (addContest_result)other;

      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id)
        {
          default:
            TProtocolUtil.skip(iprot, field.type);
            break;
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();


      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      oprot.writeStructBegin(STRUCT_DESC);

      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("addContest_result(");
      boolean first = true;

      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
      // check that fields of type enum have valid values
    }

  }

  public static class removeContest_args implements TBase, java.io.Serializable, Cloneable, Comparable<removeContest_args>   {
    private static final TStruct STRUCT_DESC = new TStruct("removeContest_args");
    private static final TField CONTEST_FIELD_DESC = new TField("contest", TType.STRUCT, (short)1);

    public ContestId contest;
    public static final int CONTEST = 1;

    // isset id assignments

    public static final Map<Integer, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new HashMap<Integer, FieldMetaData>() {{
      put(CONTEST, new FieldMetaData("contest", TFieldRequirementType.DEFAULT, 
          new StructMetaData(TType.STRUCT, ContestId.class)));
    }});

    static {
      FieldMetaData.addStructMetaDataMap(removeContest_args.class, metaDataMap);
    }

    public static final Map<String, Integer> fieldNameMap = Collections.unmodifiableMap(new HashMap<String, Integer>() {{
      put("contest", new Integer(CONTEST));
    }});

    public removeContest_args() {
    }

    public removeContest_args(
      ContestId contest)
    {
      this();
      this.contest = contest;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public removeContest_args(removeContest_args other) {
      if (other.isSetContest()) {
        this.contest = new ContestId(other.contest);
      }
    }

    public removeContest_args deepCopy() {
      return new removeContest_args(this);
    }

    @Deprecated
    public removeContest_args clone() {
      return new removeContest_args(this);
    }

    public ContestId getContest() {
      return this.contest;
    }

    public removeContest_args setContest(ContestId contest) {
      this.contest = contest;
      return this;
    }

    public void unsetContest() {
      this.contest = null;
    }

    // Returns true if field contest is set (has been asigned a value) and false otherwise
    public boolean isSetContest() {
      return this.contest != null;
    }

    public void setContestIsSet(boolean value) {
      if (!value) {
        this.contest = null;
      }
    }

    public void setFieldValue(int fieldID, Object value) {
      switch (fieldID) {
      case CONTEST:
        if (value == null) {
          unsetContest();
        } else {
          setContest((ContestId)value);
        }
        break;

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    public Object getFieldValue(int fieldID) {
      switch (fieldID) {
      case CONTEST:
        return getContest();

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    // Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise
    public boolean isSet(int fieldID) {
      switch (fieldID) {
      case CONTEST:
        return isSetContest();
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof removeContest_args)
        return this.equals((removeContest_args)that);
      return false;
    }

    public boolean equals(removeContest_args that) {
      if (that == null)
        return false;

      boolean this_present_contest = true && this.isSetContest();
      boolean that_present_contest = true && that.isSetContest();
      if (this_present_contest || that_present_contest) {
        if (!(this_present_contest && that_present_contest))
          return false;
        if (!this.contest.equals(that.contest))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      return 0;
    }

    public int compareTo(removeContest_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      removeContest_args typedOther = (removeContest_args)other;

      lastComparison = Boolean.valueOf(isSetContest()).compareTo(isSetContest());
      if (lastComparison != 0) {
        return lastComparison;
      }
      lastComparison = TBaseHelper.compareTo(contest, typedOther.contest);
      if (lastComparison != 0) {
        return lastComparison;
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id)
        {
          case CONTEST:
            if (field.type == TType.STRUCT) {
              this.contest = new ContestId();
              this.contest.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
            break;
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();


      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      validate();

      oprot.writeStructBegin(STRUCT_DESC);
      if (this.contest != null) {
        oprot.writeFieldBegin(CONTEST_FIELD_DESC);
        this.contest.write(oprot);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("removeContest_args(");
      boolean first = true;

      sb.append("contest:");
      if (this.contest == null) {
        sb.append("null");
      } else {
        sb.append(this.contest);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
      // check that fields of type enum have valid values
    }

  }

  public static class removeContest_result implements TBase, java.io.Serializable, Cloneable, Comparable<removeContest_result>   {
    private static final TStruct STRUCT_DESC = new TStruct("removeContest_result");

    public static final Map<Integer, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new HashMap<Integer, FieldMetaData>() {{
    }});

    static {
      FieldMetaData.addStructMetaDataMap(removeContest_result.class, metaDataMap);
    }

    public static final Map<String, Integer> fieldNameMap = Collections.unmodifiableMap(new HashMap<String, Integer>() {{
    }});

    public removeContest_result() {
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public removeContest_result(removeContest_result other) {
    }

    public removeContest_result deepCopy() {
      return new removeContest_result(this);
    }

    @Deprecated
    public removeContest_result clone() {
      return new removeContest_result(this);
    }

    public void setFieldValue(int fieldID, Object value) {
      switch (fieldID) {
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    public Object getFieldValue(int fieldID) {
      switch (fieldID) {
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    // Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise
    public boolean isSet(int fieldID) {
      switch (fieldID) {
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof removeContest_result)
        return this.equals((removeContest_result)that);
      return false;
    }

    public boolean equals(removeContest_result that) {
      if (that == null)
        return false;

      return true;
    }

    @Override
    public int hashCode() {
      return 0;
    }

    public int compareTo(removeContest_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      removeContest_result typedOther = (removeContest_result)other;

      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id)
        {
          default:
            TProtocolUtil.skip(iprot, field.type);
            break;
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();


      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      oprot.writeStructBegin(STRUCT_DESC);

      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("removeContest_result(");
      boolean first = true;

      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
      // check that fields of type enum have valid values
    }

  }

  public static class propertyUpdate_args implements TBase, java.io.Serializable, Cloneable, Comparable<propertyUpdate_args>   {
    private static final TStruct STRUCT_DESC = new TStruct("propertyUpdate_args");
    private static final TField EVENT_FIELD_DESC = new TField("event", TType.STRUCT, (short)1);

    public PropertyEvent event;
    public static final int EVENT = 1;

    // isset id assignments

    public static final Map<Integer, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new HashMap<Integer, FieldMetaData>() {{
      put(EVENT, new FieldMetaData("event", TFieldRequirementType.DEFAULT, 
          new StructMetaData(TType.STRUCT, PropertyEvent.class)));
    }});

    static {
      FieldMetaData.addStructMetaDataMap(propertyUpdate_args.class, metaDataMap);
    }

    public static final Map<String, Integer> fieldNameMap = Collections.unmodifiableMap(new HashMap<String, Integer>() {{
      put("event", new Integer(EVENT));
    }});

    public propertyUpdate_args() {
    }

    public propertyUpdate_args(
      PropertyEvent event)
    {
      this();
      this.event = event;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public propertyUpdate_args(propertyUpdate_args other) {
      if (other.isSetEvent()) {
        this.event = new PropertyEvent(other.event);
      }
    }

    public propertyUpdate_args deepCopy() {
      return new propertyUpdate_args(this);
    }

    @Deprecated
    public propertyUpdate_args clone() {
      return new propertyUpdate_args(this);
    }

    public PropertyEvent getEvent() {
      return this.event;
    }

    public propertyUpdate_args setEvent(PropertyEvent event) {
      this.event = event;
      return this;
    }

    public void unsetEvent() {
      this.event = null;
    }

    // Returns true if field event is set (has been asigned a value) and false otherwise
    public boolean isSetEvent() {
      return this.event != null;
    }

    public void setEventIsSet(boolean value) {
      if (!value) {
        this.event = null;
      }
    }

    public void setFieldValue(int fieldID, Object value) {
      switch (fieldID) {
      case EVENT:
        if (value == null) {
          unsetEvent();
        } else {
          setEvent((PropertyEvent)value);
        }
        break;

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    public Object getFieldValue(int fieldID) {
      switch (fieldID) {
      case EVENT:
        return getEvent();

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    // Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise
    public boolean isSet(int fieldID) {
      switch (fieldID) {
      case EVENT:
        return isSetEvent();
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof propertyUpdate_args)
        return this.equals((propertyUpdate_args)that);
      return false;
    }

    public boolean equals(propertyUpdate_args that) {
      if (that == null)
        return false;

      boolean this_present_event = true && this.isSetEvent();
      boolean that_present_event = true && that.isSetEvent();
      if (this_present_event || that_present_event) {
        if (!(this_present_event && that_present_event))
          return false;
        if (!this.event.equals(that.event))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      return 0;
    }

    public int compareTo(propertyUpdate_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      propertyUpdate_args typedOther = (propertyUpdate_args)other;

      lastComparison = Boolean.valueOf(isSetEvent()).compareTo(isSetEvent());
      if (lastComparison != 0) {
        return lastComparison;
      }
      lastComparison = TBaseHelper.compareTo(event, typedOther.event);
      if (lastComparison != 0) {
        return lastComparison;
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id)
        {
          case EVENT:
            if (field.type == TType.STRUCT) {
              this.event = new PropertyEvent();
              this.event.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
            break;
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();


      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      validate();

      oprot.writeStructBegin(STRUCT_DESC);
      if (this.event != null) {
        oprot.writeFieldBegin(EVENT_FIELD_DESC);
        this.event.write(oprot);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("propertyUpdate_args(");
      boolean first = true;

      sb.append("event:");
      if (this.event == null) {
        sb.append("null");
      } else {
        sb.append(this.event);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
      // check that fields of type enum have valid values
    }

  }

  public static class contestUpdate_args implements TBase, java.io.Serializable, Cloneable   {
    private static final TStruct STRUCT_DESC = new TStruct("contestUpdate_args");
    private static final TField CONTEST_FIELD_DESC = new TField("contest", TType.STRUCT, (short)2);
    private static final TField EVENT_FIELD_DESC = new TField("event", TType.STRUCT, (short)1);

    public ContestId contest;
    public ContestEvent event;
    public static final int CONTEST = 2;
    public static final int EVENT = 1;

    // isset id assignments

    public static final Map<Integer, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new HashMap<Integer, FieldMetaData>() {{
      put(CONTEST, new FieldMetaData("contest", TFieldRequirementType.DEFAULT, 
          new StructMetaData(TType.STRUCT, ContestId.class)));
      put(EVENT, new FieldMetaData("event", TFieldRequirementType.DEFAULT, 
          new StructMetaData(TType.STRUCT, ContestEvent.class)));
    }});

    static {
      FieldMetaData.addStructMetaDataMap(contestUpdate_args.class, metaDataMap);
    }

    public static final Map<String, Integer> fieldNameMap = Collections.unmodifiableMap(new HashMap<String, Integer>() {{
      put("contest", new Integer(CONTEST));
      put("event", new Integer(EVENT));
    }});

    public contestUpdate_args() {
    }

    public contestUpdate_args(
      ContestId contest,
      ContestEvent event)
    {
      this();
      this.contest = contest;
      this.event = event;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public contestUpdate_args(contestUpdate_args other) {
      if (other.isSetContest()) {
        this.contest = new ContestId(other.contest);
      }
      if (other.isSetEvent()) {
        this.event = new ContestEvent(other.event);
      }
    }

    public contestUpdate_args deepCopy() {
      return new contestUpdate_args(this);
    }

    @Deprecated
    public contestUpdate_args clone() {
      return new contestUpdate_args(this);
    }

    public ContestId getContest() {
      return this.contest;
    }

    public contestUpdate_args setContest(ContestId contest) {
      this.contest = contest;
      return this;
    }

    public void unsetContest() {
      this.contest = null;
    }

    // Returns true if field contest is set (has been asigned a value) and false otherwise
    public boolean isSetContest() {
      return this.contest != null;
    }

    public void setContestIsSet(boolean value) {
      if (!value) {
        this.contest = null;
      }
    }

    public ContestEvent getEvent() {
      return this.event;
    }

    public contestUpdate_args setEvent(ContestEvent event) {
      this.event = event;
      return this;
    }

    public void unsetEvent() {
      this.event = null;
    }

    // Returns true if field event is set (has been asigned a value) and false otherwise
    public boolean isSetEvent() {
      return this.event != null;
    }

    public void setEventIsSet(boolean value) {
      if (!value) {
        this.event = null;
      }
    }

    public void setFieldValue(int fieldID, Object value) {
      switch (fieldID) {
      case CONTEST:
        if (value == null) {
          unsetContest();
        } else {
          setContest((ContestId)value);
        }
        break;

      case EVENT:
        if (value == null) {
          unsetEvent();
        } else {
          setEvent((ContestEvent)value);
        }
        break;

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    public Object getFieldValue(int fieldID) {
      switch (fieldID) {
      case CONTEST:
        return getContest();

      case EVENT:
        return getEvent();

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    // Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise
    public boolean isSet(int fieldID) {
      switch (fieldID) {
      case CONTEST:
        return isSetContest();
      case EVENT:
        return isSetEvent();
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof contestUpdate_args)
        return this.equals((contestUpdate_args)that);
      return false;
    }

    public boolean equals(contestUpdate_args that) {
      if (that == null)
        return false;

      boolean this_present_contest = true && this.isSetContest();
      boolean that_present_contest = true && that.isSetContest();
      if (this_present_contest || that_present_contest) {
        if (!(this_present_contest && that_present_contest))
          return false;
        if (!this.contest.equals(that.contest))
          return false;
      }

      boolean this_present_event = true && this.isSetEvent();
      boolean that_present_event = true && that.isSetEvent();
      if (this_present_event || that_present_event) {
        if (!(this_present_event && that_present_event))
          return false;
        if (!this.event.equals(that.event))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id)
        {
          case CONTEST:
            if (field.type == TType.STRUCT) {
              this.contest = new ContestId();
              this.contest.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          case EVENT:
            if (field.type == TType.STRUCT) {
              this.event = new ContestEvent();
              this.event.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
            break;
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();


      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      validate();

      oprot.writeStructBegin(STRUCT_DESC);
      if (this.event != null) {
        oprot.writeFieldBegin(EVENT_FIELD_DESC);
        this.event.write(oprot);
        oprot.writeFieldEnd();
      }
      if (this.contest != null) {
        oprot.writeFieldBegin(CONTEST_FIELD_DESC);
        this.contest.write(oprot);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("contestUpdate_args(");
      boolean first = true;

      sb.append("contest:");
      if (this.contest == null) {
        sb.append("null");
      } else {
        sb.append(this.contest);
      }
      first = false;
      if (!first) sb.append(", ");
      sb.append("event:");
      if (this.event == null) {
        sb.append("null");
      } else {
        sb.append(this.event);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
      // check that fields of type enum have valid values
    }

  }

  public static class logEvent_args implements TBase, java.io.Serializable, Cloneable, Comparable<logEvent_args>   {
    private static final TStruct STRUCT_DESC = new TStruct("logEvent_args");
    private static final TField EVENT_FIELD_DESC = new TField("event", TType.STRUCT, (short)1);

    public LogEvent event;
    public static final int EVENT = 1;

    // isset id assignments

    public static final Map<Integer, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new HashMap<Integer, FieldMetaData>() {{
      put(EVENT, new FieldMetaData("event", TFieldRequirementType.DEFAULT, 
          new StructMetaData(TType.STRUCT, LogEvent.class)));
    }});

    static {
      FieldMetaData.addStructMetaDataMap(logEvent_args.class, metaDataMap);
    }

    public static final Map<String, Integer> fieldNameMap = Collections.unmodifiableMap(new HashMap<String, Integer>() {{
      put("event", new Integer(EVENT));
    }});

    public logEvent_args() {
    }

    public logEvent_args(
      LogEvent event)
    {
      this();
      this.event = event;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public logEvent_args(logEvent_args other) {
      if (other.isSetEvent()) {
        this.event = new LogEvent(other.event);
      }
    }

    public logEvent_args deepCopy() {
      return new logEvent_args(this);
    }

    @Deprecated
    public logEvent_args clone() {
      return new logEvent_args(this);
    }

    public LogEvent getEvent() {
      return this.event;
    }

    public logEvent_args setEvent(LogEvent event) {
      this.event = event;
      return this;
    }

    public void unsetEvent() {
      this.event = null;
    }

    // Returns true if field event is set (has been asigned a value) and false otherwise
    public boolean isSetEvent() {
      return this.event != null;
    }

    public void setEventIsSet(boolean value) {
      if (!value) {
        this.event = null;
      }
    }

    public void setFieldValue(int fieldID, Object value) {
      switch (fieldID) {
      case EVENT:
        if (value == null) {
          unsetEvent();
        } else {
          setEvent((LogEvent)value);
        }
        break;

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    public Object getFieldValue(int fieldID) {
      switch (fieldID) {
      case EVENT:
        return getEvent();

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    // Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise
    public boolean isSet(int fieldID) {
      switch (fieldID) {
      case EVENT:
        return isSetEvent();
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof logEvent_args)
        return this.equals((logEvent_args)that);
      return false;
    }

    public boolean equals(logEvent_args that) {
      if (that == null)
        return false;

      boolean this_present_event = true && this.isSetEvent();
      boolean that_present_event = true && that.isSetEvent();
      if (this_present_event || that_present_event) {
        if (!(this_present_event && that_present_event))
          return false;
        if (!this.event.equals(that.event))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      return 0;
    }

    public int compareTo(logEvent_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      logEvent_args typedOther = (logEvent_args)other;

      lastComparison = Boolean.valueOf(isSetEvent()).compareTo(isSetEvent());
      if (lastComparison != 0) {
        return lastComparison;
      }
      lastComparison = TBaseHelper.compareTo(event, typedOther.event);
      if (lastComparison != 0) {
        return lastComparison;
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id)
        {
          case EVENT:
            if (field.type == TType.STRUCT) {
              this.event = new LogEvent();
              this.event.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
            break;
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();


      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      validate();

      oprot.writeStructBegin(STRUCT_DESC);
      if (this.event != null) {
        oprot.writeFieldBegin(EVENT_FIELD_DESC);
        this.event.write(oprot);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("logEvent_args(");
      boolean first = true;

      sb.append("event:");
      if (this.event == null) {
        sb.append("null");
      } else {
        sb.append(this.event);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
      // check that fields of type enum have valid values
    }

  }

  public static class logSubscribe_args implements TBase, java.io.Serializable, Cloneable, Comparable<logSubscribe_args>   {
    private static final TStruct STRUCT_DESC = new TStruct("logSubscribe_args");
    private static final TField TEMPLATE_FIELD_DESC = new TField("template", TType.STRUCT, (short)1);

    public LogEvent template;
    public static final int TEMPLATE = 1;

    // isset id assignments

    public static final Map<Integer, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new HashMap<Integer, FieldMetaData>() {{
      put(TEMPLATE, new FieldMetaData("template", TFieldRequirementType.DEFAULT, 
          new StructMetaData(TType.STRUCT, LogEvent.class)));
    }});

    static {
      FieldMetaData.addStructMetaDataMap(logSubscribe_args.class, metaDataMap);
    }

    public static final Map<String, Integer> fieldNameMap = Collections.unmodifiableMap(new HashMap<String, Integer>() {{
      put("template", new Integer(TEMPLATE));
    }});

    public logSubscribe_args() {
    }

    public logSubscribe_args(
      LogEvent template)
    {
      this();
      this.template = template;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public logSubscribe_args(logSubscribe_args other) {
      if (other.isSetTemplate()) {
        this.template = new LogEvent(other.template);
      }
    }

    public logSubscribe_args deepCopy() {
      return new logSubscribe_args(this);
    }

    @Deprecated
    public logSubscribe_args clone() {
      return new logSubscribe_args(this);
    }

    public LogEvent getTemplate() {
      return this.template;
    }

    public logSubscribe_args setTemplate(LogEvent template) {
      this.template = template;
      return this;
    }

    public void unsetTemplate() {
      this.template = null;
    }

    // Returns true if field template is set (has been asigned a value) and false otherwise
    public boolean isSetTemplate() {
      return this.template != null;
    }

    public void setTemplateIsSet(boolean value) {
      if (!value) {
        this.template = null;
      }
    }

    public void setFieldValue(int fieldID, Object value) {
      switch (fieldID) {
      case TEMPLATE:
        if (value == null) {
          unsetTemplate();
        } else {
          setTemplate((LogEvent)value);
        }
        break;

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    public Object getFieldValue(int fieldID) {
      switch (fieldID) {
      case TEMPLATE:
        return getTemplate();

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    // Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise
    public boolean isSet(int fieldID) {
      switch (fieldID) {
      case TEMPLATE:
        return isSetTemplate();
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof logSubscribe_args)
        return this.equals((logSubscribe_args)that);
      return false;
    }

    public boolean equals(logSubscribe_args that) {
      if (that == null)
        return false;

      boolean this_present_template = true && this.isSetTemplate();
      boolean that_present_template = true && that.isSetTemplate();
      if (this_present_template || that_present_template) {
        if (!(this_present_template && that_present_template))
          return false;
        if (!this.template.equals(that.template))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      return 0;
    }

    public int compareTo(logSubscribe_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      logSubscribe_args typedOther = (logSubscribe_args)other;

      lastComparison = Boolean.valueOf(isSetTemplate()).compareTo(isSetTemplate());
      if (lastComparison != 0) {
        return lastComparison;
      }
      lastComparison = TBaseHelper.compareTo(template, typedOther.template);
      if (lastComparison != 0) {
        return lastComparison;
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id)
        {
          case TEMPLATE:
            if (field.type == TType.STRUCT) {
              this.template = new LogEvent();
              this.template.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
            break;
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();


      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      validate();

      oprot.writeStructBegin(STRUCT_DESC);
      if (this.template != null) {
        oprot.writeFieldBegin(TEMPLATE_FIELD_DESC);
        this.template.write(oprot);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("logSubscribe_args(");
      boolean first = true;

      sb.append("template:");
      if (this.template == null) {
        sb.append("null");
      } else {
        sb.append(this.template);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
      // check that fields of type enum have valid values
    }

  }

  public static class logUnsubscribe_args implements TBase, java.io.Serializable, Cloneable, Comparable<logUnsubscribe_args>   {
    private static final TStruct STRUCT_DESC = new TStruct("logUnsubscribe_args");
    private static final TField TEMPLATE_FIELD_DESC = new TField("template", TType.STRUCT, (short)1);

    public LogEvent template;
    public static final int TEMPLATE = 1;

    // isset id assignments

    public static final Map<Integer, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new HashMap<Integer, FieldMetaData>() {{
      put(TEMPLATE, new FieldMetaData("template", TFieldRequirementType.DEFAULT, 
          new StructMetaData(TType.STRUCT, LogEvent.class)));
    }});

    static {
      FieldMetaData.addStructMetaDataMap(logUnsubscribe_args.class, metaDataMap);
    }

    public static final Map<String, Integer> fieldNameMap = Collections.unmodifiableMap(new HashMap<String, Integer>() {{
      put("template", new Integer(TEMPLATE));
    }});

    public logUnsubscribe_args() {
    }

    public logUnsubscribe_args(
      LogEvent template)
    {
      this();
      this.template = template;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public logUnsubscribe_args(logUnsubscribe_args other) {
      if (other.isSetTemplate()) {
        this.template = new LogEvent(other.template);
      }
    }

    public logUnsubscribe_args deepCopy() {
      return new logUnsubscribe_args(this);
    }

    @Deprecated
    public logUnsubscribe_args clone() {
      return new logUnsubscribe_args(this);
    }

    public LogEvent getTemplate() {
      return this.template;
    }

    public logUnsubscribe_args setTemplate(LogEvent template) {
      this.template = template;
      return this;
    }

    public void unsetTemplate() {
      this.template = null;
    }

    // Returns true if field template is set (has been asigned a value) and false otherwise
    public boolean isSetTemplate() {
      return this.template != null;
    }

    public void setTemplateIsSet(boolean value) {
      if (!value) {
        this.template = null;
      }
    }

    public void setFieldValue(int fieldID, Object value) {
      switch (fieldID) {
      case TEMPLATE:
        if (value == null) {
          unsetTemplate();
        } else {
          setTemplate((LogEvent)value);
        }
        break;

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    public Object getFieldValue(int fieldID) {
      switch (fieldID) {
      case TEMPLATE:
        return getTemplate();

      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    // Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise
    public boolean isSet(int fieldID) {
      switch (fieldID) {
      case TEMPLATE:
        return isSetTemplate();
      default:
        throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
      }
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof logUnsubscribe_args)
        return this.equals((logUnsubscribe_args)that);
      return false;
    }

    public boolean equals(logUnsubscribe_args that) {
      if (that == null)
        return false;

      boolean this_present_template = true && this.isSetTemplate();
      boolean that_present_template = true && that.isSetTemplate();
      if (this_present_template || that_present_template) {
        if (!(this_present_template && that_present_template))
          return false;
        if (!this.template.equals(that.template))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      return 0;
    }

    public int compareTo(logUnsubscribe_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      logUnsubscribe_args typedOther = (logUnsubscribe_args)other;

      lastComparison = Boolean.valueOf(isSetTemplate()).compareTo(isSetTemplate());
      if (lastComparison != 0) {
        return lastComparison;
      }
      lastComparison = TBaseHelper.compareTo(template, typedOther.template);
      if (lastComparison != 0) {
        return lastComparison;
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id)
        {
          case TEMPLATE:
            if (field.type == TType.STRUCT) {
              this.template = new LogEvent();
              this.template.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
            break;
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();


      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      validate();

      oprot.writeStructBegin(STRUCT_DESC);
      if (this.template != null) {
        oprot.writeFieldBegin(TEMPLATE_FIELD_DESC);
        this.template.write(oprot);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("logUnsubscribe_args(");
      boolean first = true;

      sb.append("template:");
      if (this.template == null) {
        sb.append("null");
      } else {
        sb.append(this.template);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
      // check that fields of type enum have valid values
    }

  }

}
